## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

import numpy.oldnumeric.random_array as RandomArray
from numpy import zeros


harms={}




def initlegs(node):
    print "initlegs"
    global harms
    harms[node]=harmonics()
    node.insert_leg('ilf')
    node.insert_leg('ila')
    node.insert_leg('olf')
    node.insert_leg('ola')



class harmonic:
    def __init__(self,f,a,t):
        self.f=f
        self.a=a
        self.t=t
        self.ind=-1
    def find_next(self,peaks):
        ind=0
        for f,a in peaks:
            if self.f > f:
                ind+=1
                continue
            break
        if ind >= len(peaks):
            return len(peaks)-1
        f1=peaks[ind][0]
        f0=peaks[ind-1][0]
        if abs(f1-self.f) < abs(f0-self.f):
            return ind
        else:
            return ind-1
    def __repr__(self):
        return "%.1f-%.1f %d"%(self.f,self.a,self.t)
    def matches(self,f):
        eps=22./222
        if abs((self.f-f)) < self.f*eps:
            return True
        return False
    def process(self,peaks,t,dones):
        #print(self.f)
        ind=self.find_next(peaks)
        if ind in dones:
            self.a=0
            return False
        if ind >= 0:
            #print(fres[ind],self.f)
            (f,a)=peaks[ind]
            if self.matches(f):
                #print("matched %.1f"%self.f)
                self.ind=ind
                self.t=t
                self.a=a
                self.f=f
                return True
            else:
                pass
                #print("not matched %.1f"%fres[ind])
        self.a=0
        if (t-self.t)>3:
            #print("died %.1f"%self.f)
            #self.f=1
            return False
        return True

anz2=90



class harmonics:
    def __init__(self):
        self.harms=[]
        for j in range(anz2):
            self.harms.append(harmonic(220,0,0))
        self.candidates=[]
        self.empties=range(anz2)
        self.time=0
        self.amps=zeros(anz2,'d')
        self.fres=zeros(anz2,'d')
        anz=512
        self.f=zeros(anz,'d')
        self.a=zeros(anz,'d')
    def process(self,peaks):
        #print(10*"_")
        t=self.time
        ind=0
        dones=[]
        #print(self.empties)
        for h in self.harms:
            h.ind=-1
            if ind in self.empties:
                ind+=1
                continue
            if not h.process(peaks,t,dones):
                self.empties.append(ind)
            else: 
                dones.append(h.ind)
                #print(dones)
            ind+=1
        #print(len(dones),len(fres),len(self.empties))
        
        ind=0
        #print(self.empties)
        for c in self.candidates:
            if c.process(peaks,t,dones):
                if ind>=len(self.empties):
                    print("Too much harmonics used")
                    break
                #print("candidate accepted",c.f)
                self.harms[self.empties[ind]]=c
                dones.append(c.ind)
                ind+=1
        if ind>0:
            self.empties=self.empties[ind:]
        #print(len(self.empties))
        self.candidates=[]
        ind=0
        for f,a in peaks:
            if ind in dones:
                ind+=1
                continue
            if a <.002:
                ind+=1
                continue
            ind+=1
            self.candidates.append(harmonic(f,a,t))
        #print(len(self.candidates))
        self.time+=1
        ind=0
        for h in self.harms:
            self.amps[ind]=h.a
            self.fres[ind]=h.f
            ind+=1


def next(time,node):
    h=harms[node]
    node.get_list('ilf',h.f)
    node.get_list('ila',h.a)
    peaks=[]
    ind=0
    for ff in h.f:
        peaks.append((ff,h.a[ind]))
        ind+=1
        if ind > 80:
            break    
    peaks.sort(lambda x, y: cmp(x[1],y[1]))
    peaks.reverse()
    #print(peaks)
    h.process(peaks)
    node.set_list('olf',h.fres)
    node.set_list('ola',h.amps)

