from numpy import zeros,fft,angle
import numpy
import math
import copy

sig=zeros(256)
sigs=[]

def init(node):
    global sigs
    sigs=[]
    print("init _find_beat")

def next(time,node):
    global sigs
    node.get_signal('is',sig)
    sigs.append(copy.copy(sig))
   
    


def sigsfromfile(fname):
    import sndfile
    samps=sndfile.read(fname)
    n=len(samps)
    k=int(n/256)
    samps=array(samps[:k*256])
    sigs=samps.reshape((256,k))
    return sigs

from numpy import array,fft,cos,sin,correlate,argmax,polyfit,hamming,max

n0=64

_tempo=0
_kalman_spec=None

def refine_sigs(sigs):
    sigs=array(sigs)
    sigs.flatten()
    m=max(sigs)
    if abs(m)<.00000000000001:
        print("No signal")
    sigs=sigs.reshape((-1,n0))
    return sigs

def write_sigs(sigs):
    sigs=array(sigs)
    sigs.flatten()
    import sndfile
    sndfile.write("sig.wav",sigs)
    

def get_kalman_spec(sigs):
    sigs=refine_sigs(sigs)
    n=2*n0+1
    abs_predicted=zeros(n)
    p2=zeros(n)
    p1=zeros(n)
    
    window=hamming(4*n0)
    bands=[0,n]
    ds=[]
    for i in range(len(bands)-1):
        ds.append([])
    for i in range(1,len(sigs)-4):
        s=array(sigs[i:(i+4)])
        s=s.flatten()
        s=window*s
        s1=fft.rfft(s)
        abs_measured=abs(s1)
        phase_measured=angle(s1)
        phase_predicted=2*p1-p2
        p2=p1
        p1=phase_measured
        dx=abs_measured*cos(phase_measured)-abs_predicted*cos(phase_predicted)
        dy=abs_measured*sin(phase_measured)-abs_predicted*sin(phase_predicted)
        d=dx*dx +dy*dy
        #d=d[10:len(d)-2]
        for i in range(1,len(bands)):
            band=d[bands[i-1]:bands[i]]
            ds[i-1].append(sum(band))
    #nds=zeros(len(ds[0]))
    nds=[]
    for d in ds:
        d=array(d)
        #print(numpy.dot(d,d))
        d/=max(d)
        nds.append(d)
    global _kalman_spec
    _kalman_spec=nds
    return nds

def autocorr(x):    
    #window=hamming(len(x))
    #x*=window
    result=None
    for xx in x:
        r = correlate(xx, xx, mode='full')
        r=r[r.size/2:]
        if result==None:
            result=r
        else:
            result+=r
    return result

def crosscorr(xa,x):    
    result=None
    for xx in x:
        r = correlate(xa, xx, mode='full')
        r=r[r.size/2:]
        if result==None:
            result=r
        else:
            result+=r
    return result


def n2bpm(n):
    fre0= 44100./n0
    if n>0:
        bpm = (60*fre0)/n
        return bpm
    return None

def is_nan(x):
    return type(x) is float and x != x

def get_tempo(sigs):
    ds=get_kalman_spec(sigs)
    ass=autocorr(ds)
    ass=ass/ass[0]
    bpm=[50.,133.]
    fre0=44100./n0
    ns=[]
    norm=60.*fre0
    for b in bpm:
        ns.append(int(norm/b))
    ns.reverse()
    if ns[1]>len(ass):
        rest=ass[ns[0]:]
    else:
        rest=ass[ns[0]:ns[1]]
    if math.isnan(rest[0]):
        print("no auto")
        return 0,rest
    i=argmax(rest)+ns[0]
    #print("get_tempo %f"%i,ns)
    return fre0*60/float(i),rest


import math


def onset2lonset(onset):
    n = len(_kalman_spec[0])
    fre0 = 44100./n0
    n1 = fre0*60/_tempo
    i = int(float(n)/n1)
    x = n - n1*i + onset
    if x > n1:
        x -= n1
    return x

def get_onset(t,ds,show=False):
    if t==0:
        return 0
    f = t/60
    fre0 = 44100./n0
    n = fre0/f
    anz = len(ds)
    w=4*256/n0
    ind = int(w)
    m=len(ds[0])
    ads = zeros(m,'d')
    while ind < m-10:
        for j in range(-w,w):
            if j+ind >0 and j+ind <m:
                ads[j+ind]=1#1./math.sqrt(1+j*j)
        ind += n
    res = crosscorr(ads,ds)
    res=res[:int(n)]
    if show:
        import pylab as p
        p.figure("%d"%n0)
        p.plot(res)
        print("max %f,where %d,n %d"%(max(res),argmax(res),n))
        global _tempo,_kalman_spec
        _tempo=t
        _kalman_spec=ds
        onset2lonset(argmax(res))
        return ads[argmax(res):]
    return onset2lonset(argmax(res))
 
def tempo(node):
    f=open("save_it.pic","w")
    import cPickle
    cPickle.dump(sigs,f)
    f.close()

    print("_find_beat.py ->get_tempo")
    t,rest=get_tempo(sigs)
    global _tempo
    _tempo=t
    return t

def onset(node):
    delta = get_onset(_tempo,_kalman_spec)
    print("onset %d"%delta)
    print(float(delta*n0))
    return float(delta*n0)

if __name__=="__main__":
    import pylab as p
    f=open(r"C:\data\sonic\save_it.pic","r")
    import cPickle
    sigs0=cPickle.load(f)
    f.close()
    #fname=r"C:\data\sound\output\fsamplib_test_2.wav"
    #sigs=sigsfromfile(fname)
    sigs=sigs0
    #sigs1=array(sigs)
    #sigs1=sigs1.flatten()
    #p.figure()
    #p.plot(sigs1)
    #p.show()
    for n0 in (64,128):#(32,64,128,256):
        ds=get_kalman_spec(sigs)
        ass=autocorr(ds)
        p.figure()
        #xs = map(n2bpm,range(len(ass)))
        #print(xs[:300])
        p.plot(ass)
        t,rest=get_tempo(sigs)
        ads=get_onset(t,ds,show=True)
        print("Tempo %f"%t)
        p.figure()
        p.plot(ads)
        for i in range(len(ds)):
            p.plot(ds[i])
        p.figure()
        p.plot(rest)
        break
    p.show()

