

import sys

try:
  from OpenGL.GLUT import *
  from OpenGL.GL import *
  from OpenGL.GLU import *
except:
  print '''
ERROR: PyOpenGL not installed properly.  
        '''
  sys.exit()


def initlegs(node):
    node.insert_leg('it1')
    node.insert_leg('ie1')
    node.insert_leg('on1')
    node.insert_leg('oe1')

anz=10
num=8
kaons=[]
vels=[]
dim=666

for i in range(dim):
  vels.append([])
  for j in range(dim):
    vels[i].append([0,0])

blackout=False

from random import random
from math import *

def ctoi(c):
    global dim
    i=int(float(dim)*.5*(1.+c))
    if i>=dim:
      i=dim-1
    if i<0:
      i=0
    return i
  
class Particle:
  def __init__(self,r):
    self.reset(0)  
  def search_cut(self,how):
    global vels
    if how==0:
      gr=1
    else:
      gr=5000
    for i in range(gr):
      self.x=2*(random()-.5)
      self.y=2*(random()-.5)
      v=vels[ctoi(self.y)][ctoi(self.x)]
      if v <> [0,0]:
        return v
    print("nothing found")
    global dim
    norm=2./dim
    phase=.6*random()*random()
    return [norm*sin(phase),norm*cos(phase)]
  def reset(self,how):
    global blackout
    if blackout:
        self.c=0
    else:
        self.c=.21
    v=self.search_cut(how)
    self.age=0
    self.gr=250*random()+40
    self.vx = -v[1]
    self.vy =  v[0]
    a=2*.00001    
    self.vx += a*(random()-.5)
    self.vy += a*(random()-.5)
    self.pdraw()
  def pdraw(self):
    col=self.c
    glColor(col,col,col,.5)
    glBegin(GL_POINTS);
    #glVertex2f(self.xx,self.yy)
    glVertex2f(self.x,self.y)  
    glEnd()
    global vels
    vels[ctoi(self.y)][ctoi(self.x)]=[self.vx,self.vy]
  def move(self):
    self.xx=self.x
    self.yy=self.y
    self.x+=self.vx
    self.y+=self.vy
    cut=0
    if vels[ctoi(self.y)][ctoi(self.x)]<>[0,0]:
      cut=1
    self.pdraw()
    self.age+=1
    if cut:
      self.reset(1)
    if self.age > self.gr:
      self.reset(1)
      
  
def init(node):
  global kaons
  for i in range(num):
    x=1./num
    x*=i
    kaons.append(Particle(x))

def reset():
  for k in kaons:
    k.reset(0)
    
def int_draw():
  global anz
  glPushMatrix();
  glLoadIdentity();
  glDisable(GL_DEPTH_TEST);
  for j in range(anz):
    for i in range(num):
      kaons[i].move();
  
  glEnable(GL_DEPTH_TEST)
  glPopMatrix()

def change_color():
  global blackout
  if 10000*random()>9500:
    if blackout:
      print("white")
      blackout = False
    else:
      print("black")
      blackout = True
      
def draw(time,node):
  global anz
  anz=node.get_cache('ie1');
  if node.get_cache('it1'):
    print("Clear")
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    reset()
    blackout=False
  int_draw() 
  

print("compiling")

def next(time,node):
  print("next")
  pass
