## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

import numpy.oldnumeric.random_array as RandomArray
from numpy import zeros

def initlegs(node):
    print "initlegs"
    node.insert_leg('is')
    node.insert_leg('il')
    node.insert_leg('os')
    
anz=256

class ring_buffer:
    def __init__(self,max=100000):
       self.max=anz*(1+max/anz)
       self.x=zeros(self.max+anz,'d')
       self.pos=0
    def get(self,l):
        read_pos=self.pos-l
        if read_pos<0:
            read_pos+=self.max
        return self.x[read_pos:(read_pos+anz)]
    def set(self,input):
        self.x[self.pos:(self.pos+anz)]=input
        self.pos+=anz
        if self.pos>self.max:
            self.x[0:anz]=input
            self.pos=anz
            
class delay:
    def __init__(self,leng,rb):
        self.rb=rb
        self.interpolate=0
        self.inc=0
        self.length=leng
    def get_length(self):
        if self.interpolate > self.inc*0.5:
            return self.interpolate*self.olength+(1-self.interpolate)*self.length
        return self.length
    def get(self):
        rb=self.rb
        inc=self.inc
        if self.interpolate > inc*0.5:
            changed=arange(self.interpolate,self.interpolate-inc,-inc/anz)
            changed=changed[0:anz]
            self.interpolate-=inc
            if self.interpolate<0:
                self.interpolate=0
            return changed*rb.get(self.olength)+(1-changed)*rb.get(self.length)
        return rb.get(self.length)    
    def set_len(self,leng,time=4.):
        self.interpolate=1.
        self.inc=1./(173.*time)
        self.olength=self.length
        self.length=leng
        

class delays:
    def __init__(self,lens,max=1000000):
        self.rb=ring_buffer(max)
        self.time=0
        self.dels=[]
        self.times=[]
        self.ind=0
        for l in lens:
            self.dels.append(delay(l,self.rb))
            self.times.append(0)
    def find_oldest(self):
        min=self.time
        dmin=None
        for t,d in zip(self.times,self.dels):
            if t<=min:
                min=t
                dmin=d
        return dmin,i
    def set_length(self,y):
        for l in y:
            if l<20*anz:
                continue
            (d,i)=self.find_oldest()
            self.times[i]=self.time
            d.set_len(int(l),173*4) #4 Sekunden Uebergangszeit
    def __call__(self,input):
        self.time+=1
        out=zeros(anz,'d')
        feed=zeros(anz,'d')
        tot_norm=0
        for d in self.dels:    
            y=d.get()
            norm=8*anz/d.get_length()
            norm=sqrt(norm)
            tot_norm+=norm
            out+=y
            feed+=norm*y
        tot_norm=1.0/tot_norm
        inp=input-.001*tot_norm*feed
        self.rb.set(inp)
        #if self.time==173:
            #self.time=0
            #self.ind+=1
            #if self.ind==len(self.dels):
                #self.ind=0
            #self.dels[self.ind].set_len(1000+int(90000*random()),10*173)
        return out

from random import random
d=delays([int(90000*random())+1000 for i in range(6)])

def next(time,node):
    y=zeros(16,'d')
    node.get_list('il',y)
    d.set_length(y*anz)    
    x=zeros(anz,'d')
    node.get_signal('is',x)
    out=d(x)
    node.set_signal('os',out)