class mask:
    def __init__(self):
        self.min=0.
        self.max=1.
    def set_min(self,v):
        self.min=v
    def set_max(self,v):
        self.max=v
    def __call__(self,input):
        return self.min+(self.max-self.min)*input
    
class quantize:
    def __init__(self):
        self.intervall=1.
        self.offset=0.
        self.strength=1.
    def set_intervall(self,v):
        self.intervall=v
    def set_strength(self,v):
        self.strength=v
    def set_offset(self,v):
        self.offset=v
    def __call__(self,input):
        qvalue=self.intervall*int((input-self.offset)/self.intervall) + self.offset
        value=self.strength*qvalue +(1.-self.strength)*input
        return value
    
    
class accumulate(mask):
    def __init__(self):
        self.boundary="clip"
        self.value=0
    def __call__(self,input):
        self.value+=input
        if self.value > self.max:
            self.value=self.max
        if self.value < self.min:
            self.value=self.min
        return self.value
    
    
class dynamic:
    def __init__(self,func):
        self.values=[]
        self.func=func
    def add(self,time,value,how=1):
        self.values.append((time,value,how))
    def sort(self):
        self.values.sort()
    def __call__(self,time):
        for i,v in enumerate(self.values):
            if v[0]>time:
                break
        t0=self.values[i-1][0]
        t1=self.values[i][0]
        if t1==t0:
            x=0
        else:
            x=(time-t0)/(t1-t0)
            x=x**self.values[i][2]
        v=(1-x)*self.values[i-1][1]+x*self.values[i][1]
        self.func(v)
        
        
            
        
        