import sys, os, random, time
from math import *
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

width=640
height=400

def prepare_GL():
    """Prepare drawing.
    """
    # Viewport
    glViewport(0,0,width,height)
    # Initialize
    glClearColor(0.8,0.8,0.9,0)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glEnable(GL_DEPTH_TEST)
    glDisable(GL_LIGHTING)
    glEnable(GL_LIGHTING)
    glEnable(GL_NORMALIZE)
    glShadeModel(GL_FLAT)

    # Projection
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective (45,1.3333,0.2,20)

    # Initialize ModelView matrix
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

    # Light source
    glLightfv(GL_LIGHT0,GL_POSITION,[0,0,1,0])
    glLightfv(GL_LIGHT0,GL_DIFFUSE,[1,1,1,1])
    glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])
    glEnable(GL_LIGHT0)

    # View transformation
    gluLookAt (2.4, 7.6, 4.8, 0.5, 0.5, 0, 0, 1, 0)


# draw_body
def draw_body(body):
    """Draw an ODE body.
    """
    glPushMatrix()
    x,y,z = body.getPosition()

    R = body.getRotation()
    rot = [R[0], R[3], R[6], 0.,
           R[1], R[4], R[7], 0.,
           R[2], R[5], R[8], 0.,
           x, y, z, 1.0]
    
    glMultMatrixd(rot)
    if body.shape=="box":
        sx,sy,sz = body.boxsize
        glScale(sx, sy, sz)
        glutSolidCube(1)
    glPopMatrix()
    
bodies=None

def drawfunc ():
    # Draw the scene
    prepare_GL()
    for b in bodies:
        draw_body(b)
    glutSwapBuffers ()
    
    
def process():
    print("process")
    glutInitWindowPosition (0, 0)
    glutInitWindowSize (width, height)
    glutCreateWindow("testode")
    glutDisplayFunc (drawfunc)
    print("main loop")
    glutMainLoop()

def init(ibodies):
    global bodies
    if bodies<>None:
        print("already")
        return
    bodies=ibodies
    import thread
    thread.start_new_thread(process,())
    
init([])