import numpy as N
from math import *
from random import randint


def get_n(dur):
    return int(dur*44.1)


d0=50
n0=get_n(d0)
window0=N.blackman(n0)
#phase0=

class sin_grain:
    def __init__(self,n,f1,window_type=None):
        if n==n0:
            self.window=window0
        else:
            self.window=N.blackman(n)
        inc=2*pi*f1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        values=self.window*N.sin(phase)
        self.values=values
        
        
class chirp_grain:
    def __init__(self,n,f0,f1,window_type=None):
        if f0==f1:
            self.values=sin_grain(n,f0).values
            return
        if n==n0:
            self.window=window0
        else:
            self.window=N.blackman(n)
        inc=2*pi*1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        inc=float(f1-f0)/n
        fres=N.arange(f0,f1-inc*0.5,inc)
        print(len(fres),len(phase),n)
        phase=phase*fres
        values=self.window*N.sin(phase)
        self.values=values
        
        

        
class rand_grain:
    def __init__(self,n):
        if n==n0:
            self.window=window0
        else:
            self.window=N.blackman(n)
        from numpy.random import normal
        values=self.window*normal(0,.5,n)
        self.values=values
        
def exp_window(n):
    a=N.arange(0,float(n),1.)
    norm=.5/n
    a*=norm
    b=.5-a
    print(a)
    print(b)
    window=N.exp(-10*a)*a*b
    window=window
    #return window
    import pylab as p
    p.plot(window)
    p.show()
    
#exp_window(4000)

        
        
vocabulary=[]

def create_random_vocabulary(n):
    global vocabulary
    import time
    t0=time.time()
    for j in range(100):
        f=randint(1000,6000)
        d=randint(50,60)
        d=d0
        #vocabulary.append(chirp_grain(get_n(d),f,f+1))
        vocabulary.append(sin_grain(get_n(d),f))
    print(time.time()-t0)
    
def create_vocabulary(fres):
    global vocabulary
    import time
    t0=time.time()
    for f in fres:
        d=randint(50,60)
        d=d0
        #vocabulary.append(chirp_grain(get_n(d),f,f+1))
        vocabulary.append(sin_grain(get_n(d),f))
    print(time.time()-t0)
    
    

def create_chirp_vocabulary(f0,fres):
    global vocabulary
    vocabulary=[]
    import time
    t0=time.time()
    for f in fres:
        d=randint(10,160)
        d=d0
        #vocabulary.append(chirp_grain(get_n(d),f,f+1))
        vocabulary.append(chirp_grain(get_n(d),f,f0))
    print(time.time()-t0)



#fres=N.arange(500,4000,200)
#create_vocabulary(fres)


class create_mixture:
    def __init__(self,d,l):
        samps=N.zeros(l*44100,'d')
        n=d*l
        for j in range(n):
            which=randint(0,len(vocabulary)-1)
            g=vocabulary[which]
            pos=randint(0,44100*l-len(g.values))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
        
        
class pitch_stream:
    def __init__(self,f,l,which=None):
        samps=N.zeros(l*44100,'d')
        if which==None:
            which=randint(0,len(vocabulary)-1)
        g=vocabulary[which]
        n=f*l
        inc=float(l*(44100-len(g.values)))/n
        n=int(f*l)
        jitter=40
        for j in range(n):
            #which=randint(0,len(vocabulary)-1)
            #g=vocabulary[which]
            pos=randint(int(j*inc),int(j*inc+jitter))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
        
class create_markov_stream:
    def __init__(self,d,l):
        samps=N.zeros(l*44100,'d')
        which=randint(0,len(vocabulary)-1)
        n=d*l
        for j in range(n):
            which=randint(0,len(vocabulary)-1)
            g=vocabulary[which]
            pos=randint(0,44100*l-len(g.values))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
            

#g=chirp_grain(get_n(50),10,800)




if __name__=="__main__":
    from numpy.random import poisson,zipf
    from numpy import zeros
    from random import randint,random
    frame_length=3800
    anz_frames_step=16
    anz_frames=anz_frames_step*4
    samps=zeros(anz_frames*frame_length+400000,'d')
    offset=0
    for jj in range(10):
        voc_anz=8
        voc_anz0=voc_anz
        #create_random_vocabulary(voc_anz0)
        fres=N.arange(600,6600,50)
        create_chirp_vocabulary(2000*jj,fres)
        #vocabulary.append(rand_grain(get_n(d0)))
        voc_anz=len(vocabulary)
        voc_anz0=voc_anz
        #create_vocabulary(fres)
        markov=zeros((voc_anz,voc_anz),'d')
        for i in range(voc_anz):
            sum=0
            for j in range(voc_anz):
                x=random()
                if j==voc_anz-1:
                    x=x**.25
                x**=8
                markov[i,j]=x
                sum+=x
            for j in  range(voc_anz):
                markov[i,j]/=sum
            
        #print(markov)
        ind=0
        for i in range(anz_frames_step):
            pos=i*frame_length+offset#+randint(0,frame_length-1)
            x=random()
            i=0
            sum=markov[ind,i]
            while x>sum:
                i+=1
                sum+=markov[ind,i]
                
                
            
            ind=i
            if ind>=voc_anz0:
                continue
            n=len(vocabulary[ind].values)
            samps[(pos):(pos+n)]+=vocabulary[ind].values
        offset+=anz_frames_step*frame_length
            
    #import pylab as p
    #import time
    #t0=time.time()
    ##mix=create_mixture(200,2)
    #ps=[]
    #f0=55
    #for i in range(14):
        #ps.append(pitch_stream(f0*(i+1),2,int(i*0.5)))
    #from offline import *
    #samps=ps[0].samps
    #for p in ps[1:]:
        #samps=samps+p.samps
    #write("test.wav",samps)
    #print("Zeit ",time.time()-t0)
    import play_sound
    play_sound.play_sound(samps,amp=.1)
    #p.plot(samps)
    #p.show()
    
