import numpy as N
from math import *
from random import randint


def get_n(dur):
    #dur in ms
    return int(dur*44.1)

n0=get_n(40)
window0=N.blackman(n0)
#phase0=

class sin_grain:
    def __init__(self,n,f1,window_type=None):
        if n==n0:
            self.window=window0
        else:
            self.window=N.blackman(n)
        inc=2*pi*f1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        values=self.window*N.sin(phase)
        self.values=values
        
        
class chirp_grain:
    def __init__(self,n,f0,f1,window_type=None):
        self.window=N.blackman(n)
        inc=2*pi*1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        inc=float(f1-f0)/n
        fres=N.arange(f0,f1-inc*0.5,inc)
        print(len(fres),len(phase),n)
        phase=phase*fres
        values=self.window*N.sin(phase)
        self.values=values
        
def exp_window(n):
    a=N.arange(0,float(n),1.)
    norm=.5/n
    a*=norm
    b=.5-a
    print(a)
    print(b)
    window=N.exp(-10*a)*a*b
    window=window
    #return window
    import pylab as p
    p.plot(window)
    p.show()
    
#exp_window(4000)

        
        
vocabulary=[]

def create_random_vocabulary(n):
    global vocabulary
    import time
    t0=time.time()
    for j in range(100):
        f=randint(1000,1500)
        d=randint(50,60)
        d=40
        #vocabulary.append(chirp_grain(get_n(d),f,f+1))
        vocabulary.append(sin_grain(get_n(d),f))
    print(time.time()-t0)
    
def create_vocabulary(fres):
    global vocabulary
    import time
    t0=time.time()
    for f in fres:
        d=randint(50,60)
        d=40
        #vocabulary.append(chirp_grain(get_n(d),f,f+1))
        vocabulary.append(sin_grain(get_n(d),f))
    print(time.time()-t0)


#fres=N.arange(500,4000,200)
#create_vocabulary(fres)


class create_mixture:
    def __init__(self,d,l):
        samps=N.zeros(l*44100,'d')
        n=d*l
        for j in range(n):
            which=randint(0,len(vocabulary)-1)
            g=vocabulary[which]
            pos=randint(0,44100*l-len(g.values))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
        
        
class pitch_stream:
    def __init__(self,f,l,which=None):
        samps=N.zeros(l*44100,'d')
        if which==None:
            which=randint(0,len(vocabulary)-1)
        g=vocabulary[which]
        n=f*l
        inc=float(l*(44100-len(g.values)))/n
        n=int(f*l)
        jitter=40
        for j in range(n):
            #which=randint(0,len(vocabulary)-1)
            #g=vocabulary[which]
            pos=randint(int(j*inc),int(j*inc+jitter))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
        
class create_markov_stream:
    def __init__(self,d,l):
        samps=N.zeros(l*44100,'d')
        which=randint(0,len(vocabulary)-1)
        n=d*l
        for j in range(n):
            which=randint(0,len(vocabulary)-1)
            g=vocabulary[which]
            pos=randint(0,44100*l-len(g.values))
            samps[pos:(pos+len(g.values))]+=g.values
        self.samps=samps
            

#g=chirp_grain(get_n(50),10,800)




if __name__=="__main__":
    from numpy.random import poisson,zipf
    from numpy import zeros
    from random import randint
    frame_length=1000
    anz_frames_step=100
    anz_frames=anz_frames_step*40
    dist=poisson(2,anz_frames)
    samps=zeros(anz_frames*frame_length+400000,'d')
    offset=0
    for j in range(40):
        create_random_vocabulary(100)
        a=1.1+float(10.*j)/40
        print("a ",a)
        which=zipf(1.1+float(10.*j)/40,sum(dist))
        ind=0
        for i in range(anz_frames_step):
            for jj in range(dist[i]):
                pos=i*frame_length+randint(0,frame_length-1)+offset
                j=which[ind]
                ind+=1
                if j>=len(vocabulary):
                    j=len(vocabulary)-1
                
                n=len(vocabulary[j].values)
                samps[(pos):(pos+n)]+=vocabulary[j].values
        offset+=anz_frames_step*frame_length
            
    #import pylab as p
    #import time
    #t0=time.time()
    ##mix=create_mixture(200,2)
    #ps=[]
    #f0=55
    #for i in range(14):
        #ps.append(pitch_stream(f0*(i+1),2,int(i*0.5)))
    #from offline import *
    #samps=ps[0].samps
    #for p in ps[1:]:
        #samps=samps+p.samps
    #write("test.wav",samps)
    #print("Zeit ",time.time()-t0)
    import play_sound
    play_sound.play_sound(samps,amp=.1)
    #p.plot(samps)
    #p.show()
    
