

import sys

try:
  from OpenGL.GLUT import *
  from OpenGL.GL import *
  from OpenGL.GLU import *
except:
  print '''
ERROR: PyOpenGL not installed properly.  
        '''
  sys.exit()


def initlegs(node):
    node.insert_leg('it1')
    node.insert_leg('ie1')
    node.insert_leg('on1')
    node.insert_leg('oe1')

num=40
kaons=[]

blackout=False

from random import random
from math import *


class Particle:
  def __init__(self,r):
    self.angle=2*pi*r
    self.pos=r
    self.gr=400
    self.reset()
  def reset(self):
    global blackout
    p=self.pos
    if p>.5:
      p-=.5
    p=4*(p-.25)
    self.x =p
    self.y =0
    self.age=0
    self.gr=55*random()+22
    norm=.02
    self.vx = 0#norm*cos(self.angle)
    self.vy = norm*(1-self.pos)#*sin(self.angle)
    if self.pos>.5:
      self.vy*=-1
    if blackout:
        self.c=0
    else:
        self.c=.51
  def pdraw(self):
    col=self.c
    glColor(col,col,col,.5)
    glBegin(GL_LINE_LOOP);
    glVertex2f(self.xx,self.yy)
    glVertex2f(self.x,self.y)  
    glEnd()
    #glBegin(GL_LINE_LOOP);
    #glVertex2f(self.ox-self.xx,self.oy+self.yy)
    #glVertex2f(self.ox-self.x,self.oy+self.y)  
    #glEnd()
  def move(self):
    self.xx=self.x
    self.yy=self.y

    self.x+=self.vx
    self.y+=self.vy

    a=2*.0005    
    self.vx += a*(random()-.5)
    self.vy += a*(random()-.5)
    self.pdraw()
    self.age+=1
    
    if self.age > self.gr:
      self.reset()
      
  
def init(node):
  global kaons
  for i in range(num):
    x=1./num
    x*=i
    kaons.append(Particle(x))

def reset():
  for k in kaons:
    k.reset()
    
def int_draw():
  glPushMatrix();
  glLoadIdentity();
  glDisable(GL_DEPTH_TEST);
  
  for i in range(num):
    kaons[i].move();
  
  glEnable(GL_DEPTH_TEST)
  glPopMatrix()

def change_color():
  global blackout
  if 10000*random()>9500:
    if blackout:
      print("white")
      blackout = False
    else:
      print("black")
      blackout = True
      
def draw(time,node):
  if node.get_cache('it1'):
    print("Clear")
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    reset()
    blackout=False
  int_draw() 
  

def next(time,node):
  print("next")
  pass

