## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

import sframe
    
width=1640
height=300
width=400

def initlegs(node):
    print "response initlegs"
    node.insert_leg('ol2')
    node.insert_leg('ol1')
    node.insert_leg('il1')
    node.insert_leg('it1')
    sframe.create_glext(node,100,100,width,height,"ode")
    
import ode
from math import *

def create_box(world, space, density, lx, ly, lz):
    """Create a box body and its corresponding geom."""

    # Create body
    body = ode.Body(world)
    M = ode.Mass()
    M.setBox(density, lx, ly, lz)
    body.setMass(M)

    # Set parameters for drawing the body
    body.shape = "box"
    body.boxsize = (lx, ly, lz)

    # Create a box geom for collision detection
    geom = ode.GeomBox(space, lengths=body.boxsize)
    geom.setBody(body)

    return body

# drop_object

    
import random

anz=30

class world:
    def __init__(self):
        world = ode.World()
        world.setERP(0.8)
        world.setCFM(1E-5)
        
        # Create a space object
        space = ode.Space()
        
        # Create a plane geom which prevent the objects from falling forever
        floor = ode.GeomPlane(space, (0,1,0), 0)
        
        # A list with ODE bodies
        bodies = []
        self.ibodies={}
        self.ind=0
        self.bodies=bodies
        self.space=space
        self.world=world
        for i in range(anz):
            self.create_object()
        self.reset()
        # A joint group for the contact joints that are generated whenever
        # two bodies collide
        self.contactgroup = ode.JointGroup()
    def set_vel(self,vel):
        ind=0 
        for b in self.bodies:
            v=vel[ind]
            ind+=1
            #b.addForce((10000*v,10*v,0))
            #(x,y,z)=b.getLinearVel()
            if v>0:
                b.setLinearVel((0,50*v,0))
                b.setAngularVel((0,110*v,0))
            #b.setLinearVel((x,y+.8*v,z))
            #(x,y,z)=b.getAngularVel()
            #b.setAngularVel((x,y+.4*v,z))
        
            
    def reset(self):
        self.last={}
        self.world.setGravity( (0,-9.81,0) )
        z=.1
        for b in self.bodies:
            #b.setPosition( (4*random.gauss(0,0.1),5*random.random(),random.gauss(0,0.1)) )
            b.setPosition( (.001*random.gauss(0,0.1),z,0) )
            theta = random.uniform(0,0)#2*pi/114)
            ct = cos (theta)
            st = sin (theta)
            b.setRotation([ct, 0., -st, 0., 1., 0., st, 0., ct])
            #R=[1,0,0,0,1,0,0,0,1]
            #b.setRotation(R)
            b.setLinearVel((0,1,0))
            b.setAngularVel((0,1,0))
            z+=.3
            
    def create_object(self):
        """Drop an object into the scene."""
        body = create_box(self.world, self.space, 1000, 1.0,.2,0.3)
        self.ibodies[body]=self.ind
        self.ind+=1
        self.bodies.append(body)
        
    def near_callback(self,args, geom1, geom2):
        """Callback function for the collide() method.
        This function checks if the given geoms do collide and
        creates contact joints if they do.
        """
        # Check if the objects do collide
        #print("callback")
        
        contacts = ode.collide(geom1, geom2)
        # Create contact joints
        world,contactgroup = args
        last={}
        for c in contacts:
            b=geom1.getBody()
            if (self.last.has_key(b) or last.has_key(b))==False:
                which=self.ibodies[b]
                #print(which,b)
                #sframe.IntNoteOn(which,1,2)
            last[b]=1
            c.setBounce(0)
            c.setMu(5000)
            j = ode.ContactJoint(world, contactgroup, c)
            j.attach(geom1.getBody(), geom2.getBody())
        self.last=last
            


w=world()

def simulate():
    fps=250
    w.space.collide((w.world,w.contactgroup), w.near_callback)
    w.world.quickStep(1./fps)
    w.contactgroup.empty()

from numpy.oldnumeric import zeros

vels=zeros(256,'d')
iforce=zeros(256,'d')

rots=zeros(256,'d')


def next(time,node):
    if node.get_event("it1"):
        w.reset()
        
    node.get_list("il1",iforce)
    w.set_vel(iforce)
    simulate()
    ind=0
    for b in w.bodies:
        x,y,z = b.getLinearVel()
        R=b.getRotation()
        a=sqrt(x*x+y*y+z*z)
        phi=acos(R[3])
        if a > 10:
            a=10
        vels[ind]=y
        rots[ind]=phi
        ind+=1
    node.set_list("ol1",vels)
    node.set_list("ol2",rots)
        
        

import sys, os, random, time
from math import *
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *


def prepare_GL():
    """Prepare drawing.
    """
    # Viewport
    glViewport(0,0,width,height)
    # Initialize
    glClearColor(0.8,0.8,0.9,0)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glEnable(GL_DEPTH_TEST)
    glDisable(GL_LIGHTING)
    glEnable(GL_LIGHTING)
    glEnable(GL_NORMALIZE)
    glShadeModel(GL_FLAT)

    # Projection
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective (45,1.3333,0.2,20)

    # Initialize ModelView matrix
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

    # Light source
    glLightfv(GL_LIGHT0,GL_POSITION,[0,0,1,0])
    glLightfv(GL_LIGHT0,GL_DIFFUSE,[1,1,1,1])
    glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])
    glEnable(GL_LIGHT0)

    # View transformation
    z=5
    dist= 12.8
    gluLookAt (2.4,0,dist, 0.5, z, 0, 0, 1, 0)
    #gluPerspective(90, height/width, .1,4);



# draw_body
def draw_body(body):
    """Draw an ODE body.
    """
    glPushMatrix()
    x,y,z = body.getPosition()

    R = body.getRotation()
    rot = [R[0], R[3], R[6], 0.,
           R[1], R[4], R[7], 0.,
           R[2], R[5], R[8], 0.,
           x, y, z, 1.0]
    
    glMultMatrixd(rot)
    if body.shape=="box":
        sx,sy,sz = body.boxsize
        glScale(sx, sy, sz)
        glutSolidCube(1)
    glPopMatrix()
    
bodies=None

def drawfunc ():
    # Draw the scene
    prepare_GL()
    for b in w.bodies:
        draw_body(b)
    glFlush()
    
def draw(time,node):
    #print("python_draw")
    drawfunc()