import numpy as N
from math import *
from random import randint

def pitch2fre(p):
    fre=exp(log(2.)*float(p-69)/12)*440
    return fre

def get_n(dur):
    #dur in ms
    return int(dur*44.1)


d0=200
n0=get_n(d0)
window0=N.blackman(n0)

cache={}

class sin_grain:
    def __init__(self,n,f1,window_type=None):
        key="%d_%d"%(n,f1)
        if cache.has_key(key):
            self.values=cache[key]
            return
        if n==n0:
            self.window=window0
        else:
            self.window=N.blackman(n)
        inc=2*pi*f1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        values=self.window*N.sin(phase)
        self.values=values
        cache[key]=values
      
    
def add_notes(what,samps,n1,offset=60,amp=1):
    start=0
    for n in what:
        if n<>None:
            f=pitch2fre(n+offset)
            print(n0,n,f)
            g=sin_grain(n0,f)
            values=amp*g.values
            samps[start:(start+n1)]+=values
        start+=n1
        
        
        
def shuffle_bass(bass):
    nbass=[]
    for b in bass:
        nbass.append(b)
        nbass.append(None)
    return nbass
        
def shuffle_melodie(mel):
    nmel=[]
    for n in mel:
        nmel.append(None)
        nmel.append(n)
        
    return nmel
        
bass=[0,12]*12
melodie=[3,7,10,9,8,5,7,3]*2

melodie.extend([3,7,10,9,8,5,8,5])
print(len(bass),len(melodie))

melodie.extend([8,5]*8)
bass.extend([1,13,1,13,2,14,2,14,-1,11,-1,11,-2,10,-2,10])
melodie.extend([8,5,2,5,8,5,2,5])
bass.extend([-2,10]*4)
print(len(bass),len(melodie))

for j in range(2):
    bass.extend([-2,10]*4)
    melodie.extend([3,6]*4)
    melodie.extend([3,8]*4)
    bass.extend([0,12]*2)
    bass.extend([-1,11]*2)
    
    
bass.extend([-1,11]*7)
melodie.extend([4,8,4,8,5,8,5,8,2,8,2,5,1,5])
bass.extend([1,13]*8)
melodie.extend([6,9]*8)

bass=shuffle_bass(bass)
melodie=shuffle_melodie(melodie)

if __name__=="__main__":
    samps=N.zeros(len(bass)*n0+400000,'d')
    offset=0
    add_notes(melodie,samps,n0,offset=84)
    add_notes(bass,samps,n0,offset=72,amp=2)
    
    import play_sound
    play_sound.play_sound(samps,amp=.1)
    import offline
    offline.write("mysong1.wav",samps)
    #p.plot(samps)
    #p.show()
    
