import numpy as N
from math import *
from random import randint

def pitch2fre(p):
    fre=exp(log(2.)*float(p-69)/12)*440
    return fre

def get_n(dur):
    #dur in ms
    return int(dur*44.1)

d0=200
n0=get_n(d0)
window0=N.bartlett(n0)

cache={}

class sin_grain:
    def __init__(self,n,f1,window_type=None):
        key="%d_%d"%(n,f1)
        if cache.has_key(key):
            self.values=cache[key]
            return
        if n==n0:
            self.window=window0
        else:
            self.window=N.bartlett(n)
        #self.window*=self.window
        #self.window*=self.window
        inc=2*pi*f1/44100
        phase=N.arange(0,inc*n-inc*0.5,inc)
        values=self.window*abs(N.sin(phase))
        self.values=values
        cache[key]=values
      

def add_rh(what,samps,n1,offset=60,amp=1,start=0):
    for l in what:
        f=pitch2fre(offset)
        ll=l*n1
        g=sin_grain(ll,f)
        values=amp*g.values
        samps[start:(start+ll)]+=values
        start+=ll
    return start
        


tons=[0,2,3,5,7,8,11]
pattern1=[4,2,3,5,3,2,4]
pattern2=[2,3,5,3,2,5]
offsets= [0,1,3,4,5,3,4]

pattern2=[3,5,4,7]

def verzerrung(amp,samps):
    return N.sin(amp*samps)

if __name__=="__main__":
    seq=20*pattern1
    leng=0
    for d in seq:
        leng+=d
   
    samps=N.zeros(leng*n0+400000,'d')
    offset=0
    ind=0
    n=len(offsets)
    start=0
    times={}
    time=0
    for s in seq:
        offset=offsets[ind%n]
        ind+=1
        ps=[]
        for j in (0,2,4):
            ps.append(tons[(offset+j)%len(tons)])
        for i in range(s):
            times[time]=ps
            time+=1
        for p in ps:
            p+=60
            start0=add_rh([s],samps,n0,offset=p,start=start)
        start=start0
    #samps=.5*verzerrung(.3,samps)
    
        
    mtime=time
    for i in range(100):
        times[time]=ps
        time+=1
    time=0
    ind=0
    start=0
    while time < mtime:
        n=pattern2[ind]
        which=N.zeros(12,'i')
        for j in range(n):
            key=time+j
            #print(key,times[key])
            for k in times[key]:
                which[k]+=1
        which=list(which)
        m=max(which)
        i=which.index(m)
        start=add_rh([n],samps,n0,offset=i+60,start=start,amp=.3)
        ind+=1
        if ind >= len(pattern2):
            ind=0
        time+=n
        
    samps=verzerrung(.3,samps)
    import play_sound
    play_sound.play_sound(samps,amp=.1)
    import offline
    offline.write("rh_canon.wav",samps)
    #p.plot(samps)
    #p.show()
    
