

import sys

try:
  from OpenGL.GLUT import *
  from OpenGL.GL import *
  from OpenGL.GLU import *
except:
  print '''
ERROR: PyOpenGL not installed properly.  
        '''
  sys.exit()


def initlegs(node):
    node.insert_leg('in1')
    node.insert_leg('on1')


def init(node):
  glLightfv(GL_LIGHT1,GL_AMBIENT,(0,0,0))
  glLightfv(GL_LIGHT1,GL_DIFFUSE,(.1,1,1))
  glLightfv(GL_LIGHT1,GL_SPECULAR,(1,1,1))
  glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION,(1,1,0))
  glLightfv(GL_LIGHT0,GL_AMBIENT,(0,0,0))
  glLightfv(GL_LIGHT0,GL_DIFFUSE,(1,1,1))
  glLightfv(GL_LIGHT0,GL_SPECULAR,(1,1,1))
  glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,(1,1,0))
  print("reinit")
  global x

def next2(time,node):
    glShadeModel(GL_FLAT)
    node.gldraw('in1')


state=0

def glprint(s):
    glPushMatrix();
    glLoadIdentity();
    glDisable(GL_DEPTH_TEST);
    glRasterPos2f(10,10);
    gl_draw(s);
    glEnable(GL_DEPTH_TEST);
    glPopMatrix();


def TestSphere():
    glEnable(GL_LIGHTING)
    glDisable(GL_LIGHT0)
    glDisable(GL_LIGHT1)
    glDisable(GL_LIGHT2)
    glPushMatrix()
    glTranslatef(0,-1,0)
    glEnable(GL_LIGHT2)
    obj=gluNewQuadric()
    gluSphere(obj,1,42,42)
    glDisable(GL_LIGHT1)
    glDisable(GL_LIGHT2)
    glEnable(GL_LIGHT0)
    glTranslatef(0,2,0)
    gluSphere(obj,1,42,42)
    glPopMatrix()


    
def TestRaum():
    glEnable(GL_LIGHTING)
    glEnable(GL_LIGHT0)
    glPushMatrix()
    
    glPopMatrix()



def TestCube():
    glEnable(GL_LIGHTING)
    glEnable(GL_LIGHT0)
    glPushMatrix()
    
    glBegin(GL_POLYGON)
    glVertex3f(0,0,0)
    glVertex3f(0,1,0)
    glVertex3f(0,1,1)
    glVertex3f(0,0,1)
    glEnd()
    glBegin(GL_POLYGON)
    glVertex3f(0,0,0)
    glVertex3f(1,0,0)
    glVertex3f(1,0,1)
    glVertex3f(0,0,1)
    glEnd()
    glBegin(GL_POLYGON)
    glVertex3f(0,0,0)
    glVertex3f(1,0,0)
    glVertex3f(1,1,0)
    glVertex3f(0,1,0)
    glEnd()
    glPopMatrix()    


def Triangle():
  glDisable(GL_DEPTH_TEST)
  glEnable(GL_LIGHT2)
  glEnable(GL_LIGHTING)
  glColorf(255,0,0)
  glBegin(GL_POLYGON)
  glVertex2f(0,0)
  glVertex2f(.5,.5)
  glVertex2f(-.5,.5)
  glEnd()

spin=0
spin2=0
mults=0
mults_inc=.1

def RotateLight():
    global spin
    global spin2
    glDisable(GL_LIGHT2)
    glEnable(GL_LIGHT0)
    glEnable(GL_LIGHT1)
    glEnable(GL_LIGHT3)
    z0=4
    position =  [0.0, 0.0, z0, 1.0]
    spin = spin + 1
    spin2 = spin2 + 4
    glPushMatrix ()
    glRotated (spin, 1.0, 0.0, 0.0)
    glLightfv (GL_LIGHT0, GL_POSITION, position)
    glDisable (GL_LIGHTING)
    glColor3f (0.0, 1.0, 1.0)
    glTranslated (0.0, 0.0, z0)
    #glutWireCube (0.1)
    glEnable (GL_LIGHTING)
    glPopMatrix ()
    glPushMatrix ()
    glRotated (spin2, 0.0, 1.0, 0.0)
    glLightfv (GL_LIGHT1, GL_POSITION, position)
    glLightfv(GL_LIGHT1,GL_AMBIENT,[0,.2,0,1])
    glLightfv(GL_LIGHT0,GL_AMBIENT,[.20,0,0,1])
    glLightfv(GL_LIGHT1,GL_DIFFUSE,[0.2,.2,.20,1])
    glLightfv(GL_LIGHT0,GL_DIFFUSE,[.2,.20,0.2,1])
    glLightfv(GL_LIGHT1,GL_SPECULAR,[0,.2,.30,1])
    glLightfv(GL_LIGHT0,GL_SPECULAR,[.2,.40,0,1])
    glDisable (GL_LIGHTING)
    glColor3f (0.0, 1.0, 1.0)
    glTranslated (0.0, 0.0, z0)
    #glutWireCube (0.1)
    glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,0)
    glEnable (GL_LIGHTING)
    glPopMatrix ()
    glMaterialfv(GL_FRONT,GL_SPECULAR,[1,0,0,1])
    glMaterialf(GL_FRONT,GL_SHININESS,18)

    glColorMaterial(GL_FRONT,GL_DIFFUSE)
    glMaterialfv(GL_FRONT,GL_AMBIENT,[0.25,.250,.250,1])
    glMaterialfv(GL_FRONT,GL_DIFFUSE,[0.4,0.41,0.41,1])
    glMaterialfv(GL_FRONT,GL_SPECULAR,[.775,.775,.775,1])
    glMaterialf(GL_FRONT,GL_SHININESS,77)
    
    glPushMatrix()
    glTranslated(0,0,-6*1)
    for i in range(12):
      glTranslated(0,0,1)
      glutSolidTorus (0.275, 0.85, 22,22)
    glPopMatrix ()
    glMaterialfv(GL_FRONT,GL_AMBIENT,[.30,.30,0,1])
    glMaterialfv(GL_FRONT,GL_DIFFUSE,[0.3,0.5,0.9,1])
    glMaterialfv(GL_FRONT,GL_SPECULAR,[.5,.5,.5,1])
    glMaterialf(GL_FRONT,GL_SHININESS,32)
    global mults
    global mults_inc
    glPushMatrix()
    glTranslate(0,0,-5)
    if mults>=20:
      mults=20
      mults_inc=-.4
    if mults<=0:
      mults=0
      mults_inc=.1
    mults=mults + mults_inc
    
    glScalef(1,1,mults)
    glutSolidSphere(.75,22,22)
    glPopMatrix()
    glEnable(GL_LIGHT2)
    #glDisable(GL_LIGHTING)
  

def next(time,node):
  pass

def draw(time,node):
    Triangle()
    RotateLight()
    return
    TestSphere()
    TestCube()
    return
    glEnable(GL_LIGHTING)
    glDisable(GL_LIGHT1)
    glDisable(GL_LIGHT0)
    global state
    glprint(state)
    if state==0:    
        glEnable(GL_LIGHT1)
    if state==1:
        glEnable(GL_LIGHT0)
    state=state+1
    if state==2:
        state=0
    glDisable(GL_LIGHT1)
    glDisable(GL_LIGHT0)
    glLightfv(GL_LIGHT2,GL_AMBIENT,(1,1,1))
    glLightfv(GL_LIGHT2,GL_DIFFUSE,(1,.1,.1))
    glLightfv(GL_LIGHT2,GL_POSITION,(111,0,.1))
    glLightfv(GL_LIGHT2,GL_SPOT_DIRECTION,(-1,0,0))
    glLightfv(GL_LIGHT2,GL_DIFFUSE,(-1,0,0))
    glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,(-1,0,0))
    node.gldraw('in1')    
    
    