## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

from numpy import zeros

class SampleAtom:
    "Fills a sample into signal realtime"
    def __init__(self,a):
        self.sound=a
        self.pos=0
        self.len=len(a)
    def fill(self,out):
        for i in range(len(out)):
            out[i] += self.sound[self.pos]
            self.pos +=1
            if self.pos >= self.len:
                return True
        return False




import random
import numpy.oldnumeric.random_array as RandomArray



class RandomAtom:
    "Fills a sample into signal realtime"
    def __init__(self,dec):
        self.dec=dec
        self.amp=1
    def fill(self,out):
        xx=RandomArray.standard_normal([len(out),])
        for i in range(len(out)):
            x = xx[i]
            out[i] += self.amp * x
            self.amp *= self.dec
        if self.amp < 0.001:
            return True
        return False


class ChirpAtom:
    "Fills a sample into signal realtime"
    def __init__(self,le,p,fre,frez):
        a1=.25*(le+1)
        a2=.75*le
        le=int(le)
        amp=concatenate([arange(0,1,1/a1),arange(1,0,-1/a2)])[0:le]
        inc=2*pi*fre/44100.
        inc2=2*pi*frez/44100.
        ph=arange(0,1,1.0/le)[0:le]
        ph=power(ph,p)
        ph=inc2*ph+inc*(1-ph)
        #ph=arange(inc,inc2,(inc2-inc)/le)[0:le]
        x=0
        for i in range(le):
            x=x+ph[i]
            ph[i]=x
        self.samp=concatenate([amp*sin(ph),zeros(256,Float)])
        #plt.plot(self.samp)
        self.pos=0
        self.len=le
    def fill(self,out):
        sig=self.samp[self.pos:(self.pos+len(out))]
        out[:len(sig)]+=sig
        self.pos += len(out)
        if self.pos > self.len:
            return True
        return False    

sr=44100.

class AtomNode:
    def __init__(self):
        global sr
        self.sound=RandomArray.random([1000,])-.5
        amp=1
        for i in range(len(self.sound)):
            self.sound[i]*=amp
            amp*=.994
        self.atoms=[]
    def process(self,out,anz,l,fre0,fre_z):
        p = anz/sr
        dels=[]
        for atom in self.atoms:
            if atom.fill(out):
                dels.append(atom)
        for atom in dels:
            self.atoms.remove(atom)
        for i in range(len(out)):
            if random.random() < p:
                #atom=SampleAtom(self.sound)
                #atom=RandomAtom(dec0+(dec1-dec0)*random.random())#+random.random()*0.0099)
                atom=ChirpAtom(l,1,fre0,fre_z)
                atom.fill(out[i::])
                self.atoms.append(atom)


class DetAtomNode:
    def __init__(self):
        global sr
        self.sound=RandomArray.random([1000,])-.5
        amp=1
        for i in range(len(self.sound)):
            self.sound[i]*=amp
            amp*=.994
        self.atoms=[]
    def start(self,l,p,fre0,fre_z):
        atom=ChirpAtom(l,p,fre0,fre_z)
        self.atoms.append(atom)     
    def process(self,out):
        dels=[]
        for atom in self.atoms:
            if atom.fill(out):
                dels.append(atom)
        for atom in dels:
            self.atoms.remove(atom)
                     
       
import win32api

def open(f):
    win32api.ShellExecute(0,"open",f,None,None,1)





#def test2():
    
    #from waveio import *
    #from scipy import *
    #global sr
    #n=AtomNode()
    #signal=[]
    #for i in range(115):
        ##z=zeros(256,Float)
        #out=zeros(256,Float)
        #n.process(out,33,1111,111,222)
        #signal=concatenate([signal,out])
    ##plt.plot(signal)
    #exportWave('C:/python_sonic/wave/test.wav', sr, signal)
    #open('C:/python_sonic/wave/test.wav')



#def test():
    
    #from waveio import *
    #from scipy import *
    #global sr
    #n=DetAtomNode()
    #signal=[]
    #time=0
    #time_inc=256.0/sr
    #ind=0
    #len=1115*256
    #p=4
    #for i in range(1315):
        ##z=zeros(256,Float)
        #out=zeros(256,Float)
        #if ind==0:
            #n.start(len,p,1111,222)
            #ind=50
            #p*=.9
        #ind-=1
        #len-=256
        #n.process(out)
        #signal=concatenate([signal,out])
    ##plt.plot(signal)
    #exportWave('C:/python_sonic/wave/test.wav', sr, signal)
    #open('C:/python_sonic/wave/test.wav')    
    

def initlegs(node):
    print "initlegs"
    node.insert_leg('os1')
    node.insert_leg('ie1')
    node.insert_leg('ie2')
    node.insert_leg('ie3')
    node.insert_leg('ie4')


n=0

def init(node):
    global n
    n=AtomNode()

def next(time,node):
    global n
    out=zeros(256,Float)
    anz=node.get_value('ie1')
    l=node.get_value('ie2')
    f0=node.get_value('ie3')
    fz=node.get_value('ie4')
    #import wingdbstub
    n.process(out,anz,l,f0,fz)
    node.set_signal('os1',out)
    