## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

from numpy import zeros
from numpy.oldnumeric.random_array import random
from copy import copy
from math import sqrt
import sys
import time

class particles:
    def __init__(self,n,d):
        #print(.1*random((n,d)))
        self.pos=zeros((n,d),'d')
        #self.force=zeros((n,d),'d')
        self.vels=zeros((n,d),'d')
        self.anz=n
        self.d=d
        self.norm=.01
        self.f=6
        self.reibung=.995
        self.fixed=[]
        
    def step(self):
        self.calc_force()
        pos0=copy(self.pos)
        self.pos=self.pos+self.norm*self.vels
        self.vels=self.vels+self.norm*self.f*self.force
        self.vels*=self.reibung
        for i in self.fixed:
            self.pos[i]=pos0[i]

    def calc_index(self,x,y):
        return y*self.n+x
    
    def set_forces(self,x,y):
        feders=[]
        x1=x+1
        y1=y+1
        if x1 < self.n:
            feders.append(self.calc_index(x1,y))
        #return feders
        if y1 < self.nlayer:
            feders.append(self.calc_index(x,y1))
            
            if x1 < self.n:
                feders.append(self.calc_index(x1,y1))
            x1=x-1
            if x1 >= 0:
                feders.append(self.calc_index(x1,y1))
        return feders
    
    def set_layers(self,n,dist=1):
        self.n=n
        self.nlayer=self.anz/n
        self.dist=dist
        feders=[]
        for i in range(self.nlayer):
            for j in range(n):
                index=i*n+j
                self.pos[index]=(j*dist,i*dist)
                ind=self.calc_index(j,i)
                for f in self.set_forces(j,i):
                    feders.append((ind,f))
        self.feders=feders
        self.fixed.append(self.calc_index(0,0))
        self.fixed.append(self.calc_index(self.n-1,self.nlayer-1))
        self.fixed.append(self.calc_index(self.n-1,0))
        #self.fixed.append(self.calc_index(0,self.nlayer-1))
        self.pos+=.1*random((self.anz,self.d))
        
    def calc_force(self):
        self.force=zeros((self.anz,self.d),'d')
        for (i,j) in self.feders:
            diff=self.pos[i]-self.pos[j]
            (x,y)=diff
            r=sqrt(x*x+y*y)
            d=r-self.dist
            self.force[i]-=(d/r)*diff
            self.force[j]+=(d/r)*diff
            
    
            
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *


def prepare_GL():
    """Prepare drawing.
    """
    # Viewport
    # Initialize
    glClearColor(0.8,0.8,0.9,0)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0,1,0,1)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

def drawfunc():
    glClearColor(0,0,0,0)
    glClear(GL_COLOR_BUFFER_BIT)
    t0=time.clock()
    parts.step()
    print(1./(time.clock()-t0))
    # Draw the scene
    prepare_GL()
    glBegin(GL_POINTS)
    nx=.9/parts.n
    ny=.9/parts.nlayer
    
    for p in parts.pos:
        #a=.045*p
        (x,y)=p
        #glVertex2dv(p)
        glVertex2f(x*nx+.05,y*ny+.05)
    glEnd()
    glFlush()
    glutSwapBuffers()
    #glutPostRedisplay()
          
def init_GL():
    glutInit([])
    w=800
    h=800
    #glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitWindowSize(w,h)
    #glutInitWindowPosition(x,y) 
    glutCreateWindow('Springs')
    glutDisplayFunc(drawfunc)
    glutIdleFunc(drawfunc)
    glViewport(0,0,w,h)
    
    
if __name__=="__main__":
    parts=particles(800,2)
    parts.set_layers(20)
    init_GL()
    #print(parts.feders)
    glutMainLoop()
    

