
#include <stdio.h>
#include <math.h>
#ifdef _DEBUG
#undef _DEBUG
#include "Python.h"
#define _DEBUG
#else
#include "Python.h"
#endif 

#include "Numeric/arrayobject.h"

#ifdef springs_DLL
#ifdef springs_EXPORTS
#define springs_API __declspec(dllexport)
#else
#define springs_API __declspec(dllimport)
#endif /* field_EXPORTS */
#else
#define springs_API extern /* XXX confirm this */
#endif /* field_DLL */


#if defined(_MSC_VER)
#include <windows.h>
#define DLL extern "C" __declspec(dllexport)
#else
#define DLL
#endif


#ifdef __cplusplus
extern "C" {
#endif

inline int fast_round(double d){
	int temp_place;
	_asm {
	fld d;
	fistp temp_place;
	}
	return temp_place;
}

inline unsigned long mrand(unsigned long gr){
	static unsigned long next=1;
	next*=1103515245;
	next+=12345;
	return (next>>16)%gr;
}


inline float random(){
	static float norm=1./32768;
	return (float)mrand(32768)*norm;
}


            

#include "Numeric/arrayobject.h"

char _init_=0;
void init(){
    return;
    _init_=1;
    import_array();
    
}  

inline double *get_pointer(PyObject *what,int i){
    PyArrayObject *array =  (PyArrayObject *)what;
    return (double *)(array->data+i*array->strides[0]);
}

DLL void calc(PyObject *feders,PyObject *forces,PyObject *positions){
    if(!_init_)init();
    int anz=PyList_Size(feders);
	for(int j=0;j<anz;j++){
		PyObject *tuple=PyList_GetItem(feders,j);
		long i1=PyInt_AsLong(PyTuple_GetItem(tuple,0));
		long i2=PyInt_AsLong(PyTuple_GetItem(tuple,1));
		double *p1=get_pointer(positions,i1);
		double *p2=get_pointer(positions,i2);
		double *f1=get_pointer(forces,i1);
		double *f2=get_pointer(forces,i2);
		double dx=p1[0]-p2[0];
		double dy=p1[1]-p2[1];
		//printf("%.2f,%.2f\n",dx,dy);
		double r=sqrt(dx*dx+dy*dy);
		double d=r-1.;
		double fx=(d/r)*dx;
		double fy=(d/r)*dy;
		f1[0]-=fx;
		f1[1]-=fy;
		f2[0]+=fx;
		f2[1]+=fy;
	}
}  
 
#ifdef __cplusplus
}
#endif
