## Automatically adapted for numpy.oldnumeric Jul 21, 2008 by convert_from_numeric.py

from numpy import zeros
from numpy.oldnumeric.random_array import random
from copy import copy
from math import sqrt
import sys
import time

import sys
import os
fname=sys.modules[__name__].__file__
p=os.path.abspath(fname)
pdir=os.path.dirname(p)

import ctypes as C
csprings=C.cdll.LoadLibrary(os.path.join(pdir,"csprings.dll"))

class particles:
    def __init__(self,n,d):
        #print(.1*random((n,d)))
        self.pos=zeros((n,d),'d')
        #self.force=zeros((n,d),'d')
        self.vels=zeros((n,d),'d')
        self.anz=n
        self.d=d
        self.norm=.01
        self.f=4
        self.reibung=.999
        self.fixed=[]
        
    def step(self):
        print(self.anz,self.d)
        force=zeros((self.anz,self.d),'d')
        csprings.calc(C.py_object(self.feders),C.py_object(force),C.py_object(self.pos))
        pos0=copy(self.pos)
        self.pos=self.pos+self.norm*self.vels
        self.vels=self.vels+self.norm*self.f*force
        self.vels*=self.reibung
        for i in self.fixed:
            self.pos[i]=pos0[i]

    def calc_index(self,x,y):
        return y*self.n+x
    
    def set_forces(self,x,y):
        feders=[]
        x1=x+1
        y1=y+1
        if x1 < self.n:
            feders.append(self.calc_index(x1,y))
        if y1 < self.nlayer:
            feders.append(self.calc_index(x,y1))
            if x1 < self.n:
                feders.append(self.calc_index(x1,y1))
            x1=x-1
            if x1 >= 0:
                feders.append(self.calc_index(x1,y1))
        return feders
    
    def reset_pos(self):
        self.vels=zeros((self.anz,self.d),'d')
        for i in range(self.nlayer):
            for j in range(self.n):
                index=i*self.n+j
                self.pos[index]=(j*dist,i*dist)
                
    def set_layers(self,n,dist=1):
        self.n=n
        self.nlayer=self.anz/n
        self.dist=dist
        feders=[]
        for i in range(self.nlayer):
            for j in range(n):
                index=i*n+j
                self.pos[index]=(j*dist,i*dist)
                ind=self.calc_index(j,i)
                for f in self.set_forces(j,i):
                    feders.append((ind,f))
        self.feders=feders
        #self.fixed.append(self.calc_index(0,0))
        #self.fixed.append(self.calc_index(self.n-1,self.nlayer-1))
        self.fixed.append(self.calc_index(self.n-1,0))
        self.fixed.append(self.calc_index(0,self.nlayer-1))
        #self.fixed.append(self.calc_index(0,self.nlayer-1))
        self.pos0=copy(self.pos)
        self.pos+=.1*random((self.anz,self.d))
        
    def get_diffs(self):
        p=self.pos-self.pos0
        return p[:,0],p[:,1]

    def get_vels(self):
        p=self.vels
        return p[:,0],p[:,1]
    
    def get_pos(self):
        p=self.pos
        return p[:,0],p[:,1]
    
            
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

def prepare_GL():
    """Prepare drawing.
    """
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0,1,0,1)
    #glMatrixMode(GL_MODELVIEW)
    #glLoadIdentity()


offset=.01
dist=1.-2*offset
inc=.001
my_time=0

def step():
    parts.step()
    
    
def drawtime():
    
    glBegin(GL_LINES)
    glVertex2f(my_time+offset,offset)
    glVertex2f(dist*my_time+offset,1-offset)
    glEnd()
    
    
def drawfunc():
    glClearColor(0,0,0,0)
    glClear(GL_COLOR_BUFFER_BIT)
    #t0=time.clock()
    parts.step()
    #print(1./(time.clock()-t0))
    # Draw the scene
    prepare_GL()
    glBegin(GL_LINES)
    nx=dist/parts.n
    ny=dist/parts.nlayer
    for p in parts.pos:
        (x,y)=p
        glVertex2f(x*nx+offset,y*ny+offset)
    glEnd()
    #drawtime()
    glFlush()
    
def glut_drawfunc():
    global my_time
    my_time+=inc
    if my_time > 1.:
        my_time=0
    step()
    drawfunc()
    glutSwapBuffers()
          
def init_GL():
    glutInit([])
    w=800
    h=800
    #glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitWindowSize(w,h)
    #glutInitWindowPosition(x,y) 
    glutCreateWindow('Springs')
    glutDisplayFunc(glut_drawfunc)
    glutIdleFunc(glut_drawfunc)
    glViewport(0,0,w,h)
    
    
if __name__=="__main__":
    parts=particles(1000,2)
    parts.set_layers(30)
    init_GL()
    #print(parts.feders)
    glutMainLoop()
    