

import sys

try:
  from OpenGL.GLUT import *
  from OpenGL.GL import *
  from OpenGL.GLU import *
except:
  print '''
ERROR: PyOpenGL not installed properly.  
        '''
  sys.exit()


def initlegs(node):
    node.insert_leg('it1')
    node.insert_leg('ie1')
    node.insert_leg('on1')
    node.insert_leg('oe1')
   
num = 5
numtravelers = 200
mind = 64
nudge = 0

cities=[]

from random import random
from math import *


def setup():
  global cities,num,nudge
  nudge = 2.0/num
  i=0
  for n in range(num*num):
    cities.append(City(n))
      #cities[i] = new City(int(x*nudge+nudge/2),int(y*nudge+nudge/2),i);
   
def point(x,y):
  glBegin(GL_POINTS)
  glVertex2f(x,y)
  glEnd()
  
    
def int_draw():
  global cities,num,nudge,numtravelers
  glPushMatrix();
  glLoadIdentity();
  glDisable(GL_DEPTH_TEST);
   
  for n in range(numtravelers):
    # pick random city A
    a = int(num*num*random())-1
    b = int(num*num*random())-1
    if a!=b:
      if citydistance(a,b)<mind:
        # pick random distance between city
        t = pi*random()
        dx = sin(t)*(cities[b].xp-cities[a].xp)+cities[a].xp
        dy = sin(t)*(cities[b].yp-cities[a].yp)+cities[a].yp

        if 1000*random()>990:
          # noise
          norm=2*1.5
          dx += norm*(random()-1)
          dy += norm*(random()-1)
        glColor(cities[b].myc[0],cities[b].myc[1],cities[b].myc[2],.5)
        point(dx,dy)
        glColor(cities[a].myc[0],cities[a].myc[1],cities[a].myc[2],.5)
        point(dx,dy)
  for c in range(num*num):
    cities[c].move()
  glEnable(GL_DEPTH_TEST)
  glPopMatrix()

def citydistance(a,b):
  if a!=b:
    # calculate and return distance between cities
    Dx = cities[b].xp-cities[a].xp
    Dy = cities[b].yp-cities[a].yp
    D = sqrt(Dx*Dx+Dy*Dy)
    return D
  return 0.0
  

class City:
  def __init__(self,Idx):
    global nudge
    self.xp = 0
    self.yp = 0
    self.idx = Idx
    self.myc=(random(),1,random())
    # pick destination
    self.destx = num*random()*nudge+nudge/2-1.2
    self.desty = num*random()*nudge+nudge/2-1.2
    self.vx=0
    self.vy=0
  def draw(self):
    glColor(1,.5,.3)
    point(self.xp,self.yp)
  def move(self):
    norm=1.0/11500
    self.vx+=(self.destx-self.xp)*norm
    self.vy+=(self.desty-self.yp)*norm
    self.vx*=0.973
    self.vy*=0.973
    self.xp+=self.vx
    self.yp+=self.vy
    self.draw()


  
def init(node):
  setup()

def reset():
  for k in kaons:
    k.reset()
    

def change_color():
  global blackout
  if 10000*random()>9500:
    if blackout:
      print("white")
      blackout = False
    else:
      print("black")
      blackout = True
      
def draw(time,node):
  if node.get_cache('it1'):
    print("Clear")
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    #reset()
  int_draw() 
  

def next(time,node):
  print("next")
  pass

