
from numpy import zeros
import random

def initlegs(node):
    print "initlegs"
    node.insert_leg('iek')
    node.insert_leg('ief')
    node.insert_leg('iedf')
    node.insert_leg('ol1')


dim=20
omegas=zeros(dim,Float)
phases=zeros(dim,Float)

def init(node):
    global dim
    global omegas
    global phases
    for i in range(dim):
        omegas[i]=2*random.random()-1

def all_coupling(k):
    global dim
    k/=dim
    forces=zeros(dim,Float)
    for i in range(dim):
        x=phases[i]
        for j in range(dim):
            forces[i]-=k*sin(x-phases[j])
    return forces

def mean_coupling(k):
    global dim
    forces=zeros(dim,Float)
    x=0
    for i in range(dim):
        x+=phases[i]
    x/=dim
    for i in range(dim):
        forces[i]=-k*sin(phases[i]-x)
    return forces


def some_coupling(k):
    global dim
    forces=zeros(dim,Float)
    for i in range(dim):
        for e in range(4):
            j=random.randint(0,dim-1)
            forces[i]+=-k*sin(phases[i]-phases[j])
    return forces
    
def next(time,node):
    global dim
    global omegas
    global phases
    k=node.get_value('iek')
    f=2*pi*node.get_value('ief')
    df=node.get_value('iedf')
    forces=some_coupling(k)
    norm=1.0/173.0
    for i in range(dim):
        phases[i]+=norm*(f+f*df*omegas[i]+forces[i])
        if phases[i]>2*pi:
            phases[i]-=2*pi
    node.set_list('ol1',sin(phases))
    