from bluetooth import BluetoothSocket, BluetoothError, L2CAP, widcomm
import thread, time

#widcomm.widcomm_reset()


# Wait <millis> milliseconds
def wait(millis):
    time.sleep(millis / 1000.0)

#funktioniert mit sync Knopf im Bateriefach!!!!!!!!!!!!

connected=0

import mmap

data=None


def send_command(cmd,what,data):
    data_str=""
    for d in data:
        data_str+=d
    fdout.send(chr(cmd)+chr(what)+data_str)

def send_led(state):
    a=chr(state*16)
    send_command(0x52,0x11,[a])


def send_vibra(state):
    a=chr(state)
    send_command(0x52,0x11,[a])

def c2i(a):
    return int(a.encode("hex"),16)


def start_acc():
    fdout.send("\x52\x12\x00\x31")
    #Diese Zeile brauchts um Beschleunigungsdaten zu bekommen

def start():
    global data
    data = mmap.mmap(0,1024,"wii")
    data.flush()
    global connected,fdin,fdout
    ADDRESS="00:19:1D:AA:8A:4B"
    #ADDRESS="00:19:1d:9a:f8:a1"
    # Try to connect to Wiimote
    print 'connecting to Wiimote ' + ADDRESS + ', please press buttons 1 and 2'
    fdin = BluetoothSocket(L2CAP)
    fdin.connect((ADDRESS, 0x13))
    fdout = BluetoothSocket(L2CAP)
    fdout.connect((ADDRESS, 0x11))
    if not fdin or not fdout:
        raise 'could not connect to Wiimote, check the address'
    # Open window
    # Run listener

    connected = 1
    start_acc()
    send_led(0)


from wiimote import *

class from_wii_class:
    def update(self,w):
        #self.tg=w.theta_g
        #self.tgx=w.theta_g_x
        self.acc=[]
        self.nacc=[]
        self.njoy=[]
        for i in range(3):
            self.acc.append(w.force[i])
            self.nacc.append(w.nforce[i])
        for i in range(2):
            self.njoy.append(w.njoy[i])
        self.acc=tuple(self.acc)
        self.nacc=tuple(self.nacc)
        #self.dots=w.dots
        self.buttonmask=w.buttonmask
        self.nbuttomask=w.nbutton
        self.nbuttonmask=w.nbutton

from_wii=from_wii_class()

class to_wii_class:
    pass

import time
import pickle

time0=time.time()

def write_short(data,l):
    data.write_byte(chr(l/256))
    data.write_byte(chr(l%256))
    
def read_short(data):
    h=ord(data.read_byte())
    l=ord(data.read_byte())
    return h*256+l

    
def dump(from_wii):
    s=pickle.dumps(from_wii)
    if rec_dic<>None:
        key=str(time.time()-time0)
        rec_dic[key]=s
    data.seek(0)
    write_short(data,len(s))
    data.write(s)

def output(w):
    from_wii.update(w)
    dump(from_wii)

def input(w):
    data.seek(512)
    l=ord(data.read_byte())
    s=data.read(l)
    try:
        to_wii=pickle.loads(s)
        if to_wii.read:
            #print("Client listening")
            pass
    except:
        pass
    data.seek(512)
    data.write_byte(chr(0))



def start_wiimote():
    w=Wiimote(fdin,fdout)
    opt.debug=True
    opt.verbose=True
    print "Enabling accelerometer and Nunchuck."
    #w.enable_force()
    w.enable_nun()
    #print "Turning on IR camera."
    #w.enable_IR()
    #IR-Camera needs power!

    #if opt.uinput and uinput_dev:
    #	print "Initializing uinput device."
    #	fd = init_uinput(uinput_dev)
    last=time.time()

    while not w.done:
        #wait(5)
        w._getpacket()
        #sys.stdout.write("%d,%d\r"%(64==w.nbutton&64,128==w.nbutton&128))
        #sys.stdout.flush()
        output(w)
        input(w)
        dots=w.dots
        #w.showstatus()


def destroy():
    global connected
    connected=0
    fdout.close()
    wait(11)
    fdin.close()
    if rec_dic <> None:
        stop_record()

def exit():
    destroy()

def quit():
    destroy()

def stop():
    destroy()

def q():
    destroy()

def x():
    destroy()

import shelve

rec_dic=None
rec_path="d:/sonic/data/wii.txt"

def record():
    global rec_dic
    rec_dic=shelve.open(rec_path)
    rec_dic.clear()


def stop_record():
    global rec_dic
    rec_dic.close()
    rec_dic=None



def start_read():
    print("start_simulate")
    global data
    dic=shelve.open(rec_path)
    data = mmap.mmap(0,1024,"wii")
    #try:
    times=[]

    for e in dic.keys():
        times.append(float(e))
    times.sort()
    t0=time.time()-times[0]
    for t1 in times:
        wait(5)
        k=str(t1)
        while True:
            dt=time.time()-t0
            if dt>t1:
                from_wii=pickle.loads(dic[k])
                dump(from_wii)
                #print(t1)
                break
    #finally:
    dic.close()
    print("finished")

if __name__ == "__main__":	
    start()
    thread.start_new_thread(start_wiimote, ())
    print("Type record() to record, x() to stop wii")	

