
from numpy import zeros
from RandomArray import random

panz=10
n=10



def normalize(vec):
    n=dot(vec,vec)/len(vec)
    if n>0:
        n=pow(n,-.5)
    vec*=n
    
def gradient(a,fitness):
    f0=fitness(a)
    epsilon=.0001
    grad=zeros([len(a)],'d')
    for i in range(len(a)):
        b=a.copy()
        b[i]+=epsilon
        f1=fitness(b)
        diff=f1-f0
        grad[i]=diff
    normalize(grad)
    return grad

def grad_min(a,fitness,min,max):
    #print("grad_min")
    g=gradient(a,fitness)
    norm=-.1
    f0=fitness(a)
    while True:
        b=a.copy()
        b+=norm*g
        #b=clip(b,min,max)
        f=fitness(b)
        if f<f0:
            return [True,b]
        norm*=.5
        if norm > -.0001:
            return [False,a]
    

def grad_method(a,fitness,min,max):
    while True:
        [flag,a]=grad_min(a,fitness,min,max)
        if not flag:
            return a
    
population=[]

def init_population(anz):
    global population
    global panz
    population=[]
    for i in range(anz):
        population.append(random([panz]))


def evaluate(fitness,min,max):
    min = 1000
    min_x = []
    for p in population:
        #b=fmin(fitness,p,(), 1e-4, 1e-4,None, None, 0, 0)
        b=grad_method(p,fitness,min,max)
        x=fitness(b)
        a=fitness(p)
        if x < min:
            min = x
            min_x = b
    return [min,min_x]
    
