from sframe import *


feature_anz=15

def process_some(n):
    for i in range(n):
        process()
    nn=get_node("read_by_python")
    li=get_list(nn)
    return li

from RandomArray import *

from feature import *

def calc_abstand(cov,chrom,ziel):
    for ind in range(len(chrom)):
        c=get_const(ind+1)
        c.set_to(chrom[ind])
    li=process_some(2)
    return abstand(cov,ziel,li)
    
def find_near_one(cov,ziel,anz,last):
    global feature_anz
    min=last
    min_a=calc_abstand(cov,last,ziel)
    for offset in range(feature_anz/3):
        for i in range(700):
            chrom=random([feature_anz])
            chrom[0:feature_anz]=min
            chrom[3*offset:(3*(offset+1))]=random([3])
            abstand=calc_abstand(cov,chrom,ziel)
            if abstand < min_a:
                min_a=abstand
                print(i,' ',min_a)
                min=chrom
                #if min_a < .0001:
                #    return min
    return min

def gradient(cov,ziel,x):
    abstand=calc_abstand(cov,x,ziel)
    gradient=Numeric.zeros([len(x)],'d')
    epsilon=0.001
    for i in range(len(x)):
        x1=x.copy()
        x1[i]= x1[i]+epsilon
        abstand1=calc_abstand(cov,x1,ziel)
        gradient[i]=(abstand1-abstand)
    norm=Numeric.dot(gradient,gradient)
    if norm>0:
        norm=pow(norm,-.5)
    return gradient*norm

def refine_solution(cov,ziel,chrom,min_a):
    m=min_a
    count=0
    mult=1
    gr=gradient(cov,ziel,chrom)
    while True:
        chrom2=chrom-mult*gr
        chrom2=Numeric.clip(chrom2,0,1)
        abstand=calc_abstand(cov,chrom2,ziel)
        if abstand >= min_a:
            mult*=.5
            if mult < .01:
                break
            continue
        count=count+1
        if abstand < min_a:
            min_a=abstand
            chrom=chrom2
            gr=gradient(cov,ziel,chrom)
    if min_a < m:
        print("refined ",m/min_a,"anz ",count)
    return [chrom,min_a]

def find_solution(cov,ziel):
    #print("find_solution")
    min=[]
    min_a=1000
    global feature_anz
    block_anz=feature_anz/3
    for i in range(200):
        chrom=random([feature_anz])
        abstand=calc_abstand(cov,chrom,ziel)
        if abstand < min_a:
            min=chrom
            min_a=abstand
            if min_a < 10:
                [min,min_a]=refine_solution(cov,ziel,min,min_a)
    print("solution_error ",min_a)
    return [min,min_a]

solutions=[]
errors=[]

def export(cov):
    f=open('c:/sonic/data/map/test.txt','w')
    f.write(str(len(classes[0]))+' '+str(len(solutions[0]))+'\n')
    for i in range(len(cov)):
        f.write(str(cov[i])+' ')
    f.write('\n')
    for i in range(len(classes)):
        for j in range(len(classes[i])):
            f.write(str(classes[i][j]))
            f.write(' ')
        f.write('\n')
        for j in range(len(solutions[i])):
            f.write(str(solutions[i][j]))
            f.write(' ')
        f.write('\n')
        f.write(str(errors[i])+'\n')
    f.close()
 
        
def solution_finder(cov):
    global classes
    global errors
    i=0
    for c in classes:
        i=i+1
        if i%4==0:
            print(i)
        [s,e]=find_solution(cov,c)
        solutions.append(s)
        errors.append(e)
    export(cov)
    #print(errors)
    #print(solutions)
 


def find_near_solution(cov,ziel):
    global solutions
    global classes
    min=[]
    min_a=1000
    for ind in range(len(classes)):
        c=classes[ind]
        s=solutions[ind]
        ab=abstand(cov,ziel,c)
        if ab < min_a:
            min=s
            min_a=ab
    return min
        

def find_solutions():
    global feature_anz
    cov=analyze_features(100)
    print(cov)
    c=get_const(0)
    c.set_from_value(1)
    solution_finder(cov)

    
def do_it():
    stop_audio()
    hm=get_node("hash_map")
    hm.active=False
    bang=get_node("bang")
    bang.double_click()
    res=find_solutions()
    hm.active=True
    hm.load()
    #start_audio()

do_it()    




