from Tkinter import *

class Draw:
    """Just a Tk.Canvas with line wrapper"""
    def __init__(self):
        self.root=Tk()
        self.canvas = Canvas(self.root, background="white")
        self.canvas.pack(expand=1, fill="both")#self.canvas=Canvas(self)
    def line(self,x1,x2):
        h=self.canvas.winfo_height()
        w=self.canvas.winfo_width()
        self.canvas.create_line(w*x1[0],h*x1[1],w*x2[0],h*x2[1])



class Turtle:
    """Turtle-Style Drawings"""
    def __init__(self,draw):
        self.draw=draw
        self.direction=(.003,0)
        self.reset()
    def turn(self,angle):
        from math import cos,sin
        x=self.direction[0]
        y=self.direction[1]
        c=cos(angle)
        s=sin(angle)
        self.direction=(c*x-s*y,c*y+s*x)
    def turn4(self,i):
        from math import pi
        angle=i*pi/2
        self.turn(angle)
    def set_inc(self,inc):
        self.direction=(inc,0)        
    def step(self,centre):
        x=self.pos[0]
        y=self.pos[1]
        vx=self.direction[0]
        vy=self.direction[1]
        acc=-.0001*centre
        vx+=acc*x
        vy+=acc*y
        xx=x+vx
        yy=y+vy
        self.draw.line(self.pos,(xx,yy))
        self.pos=(xx,yy)
        self.draw.canvas.update()
        #if xx < 0 or yy < 0 or xx>1 or yy >1:
         #   self.reset()
    def reset(self):
        self.pos=(0,1)
        #self.draw.canvas.clear()



draw=Draw()
turtle=Turtle(draw)

def random_walk(size):
    global turtle
    from random import random
    for i in range(size):
        turtle.turn(random()-.5)
        turtle.step(1)


def grammar_walk(s):
    """interprets a string as turtle-commands"""
    turtle.set_inc(.01)
    for c in s:
        if c=='r':
            turtle.turn4(-1)
        if c=='l':
            turtle.turn4(1)
        if c=='f':
            turtle.step(0)

def make1(rules,start):
    """apply substitution rules to string start"""
    res=''
    for i in range(len(start)):
        if i < len(start)-1:
            s=start[i:i+2]
            if rules.has_key(s):
                res += rules[s]
                i+=1
        if rules.has_key(start[i]):
            res += rules[start[i]]
        else:
            res += start[i]
    return res

def make(rules,n,start):
    """apply n-times rules to string start"""
    for e in range(n):
        start=make1(rules,start)
    return start

def get_string():
    """generate grammar_string"""
    rules={'x':'ryflxfxlfyr','y':'lxfryfyrfxl'}
    return make(rules,7,'x')
    

    
def grammar():
    grammar_walk(get_string())


class interpret_string:
    """Make events out of a string"""
    def __init__(self,s):
        """For each character i the string there
        has to be a method handle_i on interpret_string!!!"""
        self.time=0
        self.delta=1.0/16
        self.track=0
        for c in s:
            method=getattr(self,'handle_'+c)
            method()
    def make_item(self):
        try:
           import sframe
           sframe.make_item(self.track,self.time,'1')
        except:
            s='sframe.make_item(%d,%s,1)'%(self.track,self.time)
            print(s)
    def handle_1(self):
        self.time+=self.delta
        self.make_item()
    def handle_2(self):
        self.time+=2*self.delta
        self.make_item()
        self.track=1
        self.make_item()
        self.track=0
    def handle_3(self):
        self.time+=2*self.delta
        self.make_item()
    def handle_0(self):
        self.time+=4*self.delta
        self.make_item()
    def handle_5(self):
        self.time+=self.delta
        x=4*self.time
        x=int(x)+1
        self.time=float(x)/4
        self.make_item()
        self.track=1
        self.make_item()
        self.track=2
        self.make_item()
        self.track=0
    
#interpret_string(get_string())

import thread
thread.start_new_thread(grammar,())
