#include "standart.h"
#include "StringLeg.h"
#include "pythonnode.h"






PyTypeObject pythonnode::Type = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,				/*ob_size*/
	"pythonnode",			/*tp_name*/
	sizeof(pythonnode),			/*tp_basicsize*/
	0,				/*tp_itemsize*/
	/* methods */
	0,	  		/*tp_dealloc*/
	0,			 	/*tp_print*/
	__getattr,			/*tp_getattr*/
	0, 			/*tp_setattr*/
	0,			        /*tp_compare*/
	0,		        	/*tp_repr*/
	0,			        /*tp_as_number*/
	0,		 	        /*tp_as_sequence*/
	0,			        /*tp_as_mapping*/
	0,			        /*tp_hash*/
	0//pythonnode::Methods,			/*tp_call */
};

void pythonnode::insert_leg(const char *key){
	_init=1;
	if(legs.find(key)!=legs.end()){
		//printf("Leg %s already defined\n",key);
		return;
	}
	if(key[0]=='i')
		legs[key]=new_input(key[1],&key[2]);
	if(key[0]=='o'){
		legs[key]=new_output(key[1],&key[2]);
		if(key[1]=='l'){
			L_Out_Leg *ll=(L_Out_Leg *)legs[key];
			ll->list=new ev_list();
		}
	}
	vnodes->define_legs();
}

PyObject *pythonnode::_getattr(char *attr)
{
  //if (streq(attr, "type"))
  //  return Py_BuildValue("s", (*(GetParents()))->tp_name);
  return Py_FindMethod(Methods, this, attr);    
}


PyMethodDef pythonnode::Methods[] = {
	{"insert_leg",         (PyCFunction)py_insert_leg,         Py_NEWARGS},
	{"set_value",          (PyCFunction)py_set_value,         Py_NEWARGS},
	{"get_value",          (PyCFunction)py_get_value,         Py_NEWARGS},
	{"get_cache",          (PyCFunction)py_get_cache,         Py_NEWARGS},
	{"set_signal",          (PyCFunction)py_set_signal,         Py_NEWARGS},
	{"get_signal",          (PyCFunction)py_get_signal,         Py_NEWARGS},
	{"set_list",          (PyCFunction)py_set_list,         Py_NEWARGS},
	{"get_list",          (PyCFunction)py_get_list,         Py_NEWARGS},
	{"set_event",          (PyCFunction)py_set_event,         Py_NEWARGS},
	{"get_event",          (PyCFunction)py_get_event,         Py_NEWARGS},
	{"get_seq_time",       (PyCFunction)py_get_seq_time,     Py_NEWARGS},
	{"gldraw",       (PyCFunction)py_gldraw,     Py_NEWARGS},
	{"note",       (PyCFunction)py_note,     Py_NEWARGS},
	{"dict",       (PyCFunction)py_dict,     Py_NEWARGS},
	{"get_attr_string",       (PyCFunction)py_get_attr_string,     Py_NEWARGS},
	{NULL, NULL}		/* Sentinel */
};


//#include "pythonnode.h"
#include "Numeric/arrayobject.h"

#include <direct.h>

#include "Sequencer.h"
#include "utilities.h"

extern void find_and_replace(string& source,const string &find,const string& replace);

const char *pythonnode::path(){
	string s=vnodes->external_name;
	find_and_replace(s,".","/");
	fname=window_container->dir0+"\\Code\\python\\python_node\\"+s+".py";
	//name="c:\\sonic\\Code\\python\\python_node\\"+vnodes->external_name+".py";
	return fname.c_str();
}


//#include <sys/stat.h><wchar.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>


char pythonnode::modified(){
	string p=path();
	FILE *f=fopen(p.c_str(),"r");
	if(!f)return 0;
	struct __stat64 info;
	_fstat64(_fileno(f),&info);
	fclose(f);
    long time=info.st_mtime;
	if(p!=old_path){
		old_path=p;
		last_mod_time=time;
		return 1;
	}
    char out=0;
    if(last_mod_time != time){
	   printf("File %s modified\n",path());
	   out=1;
    }
    last_mod_time=time;
    return out;
}

void pythonnode::double_click(){
	string name=path();
	/*FILE *f=fopen(path(),"r");
	if(!f){
		printf("Datei %s existiert nicht\n",name.c_str());
		return;
	}
	fclose(f);
	*/
	window_container->edit(name);
	//ShellExecute(0,"open",name.c_str(),"", "",SW_SHOWNORMAL);
	//ShellExecute(0,"edit",name.c_str(),"", "",SW_SHOWNORMAL);
}
extern void destroy_glext(pythonnode *n);


PyObject *get_func(PyObject *module,char *name){
	if(!PyObject_HasAttrString(module,name))
		return 0;
	return PyObject_GetAttrString(module,name);
}


void pythonnode::will_be_removed(){
	destroy_glext(this);
	container->delay_remove(this);
	container->non_realtime->remove(this);
	//PyObject *stop = get_func(module,"stop");
	//if(stop)call_python2(stop);
}


void pythonnode::after_creation(){
	dict=PyDict_New( );
	vnodes->first_node=this;
	pinitlegs=pnext=pinit=0;
	_init=0;
	import_module(vnodes->external_name.c_str());
	container->non_realtime->append(this);
	container->delay_append(this);
	after=1;non_realtime=0;normal=0;
	
}

extern void init_python();





void pythonnode::attributes(char in){
	vnodes->seti("after_process",after,in);
	vnodes->seti("non_realtime",non_realtime,in);
	string old=a_string;
	vnodes->sets("a_string",a_string,in);
	if(a_string!=old){
		call_python2(pinit);
	}
	if(after){
		non_realtime=normal=0;
		return;
	}
	if(non_realtime){
		after=normal=0;
		return;
	}
	normal=1;
}

/*
void pythonnode::import_module(const char *title){
	attributes(0);
	modified();
	failed=0;
	//PyGILState_STATE gstate= PyGILState_Ensure();
	//char a[1000];
	//strcpy(a,title);
	PyObject *newmodule=0;
	char skript[100];
	init_python();
	//PyEval_AcquireLock();
	//this->vnodes->id
	sprintf(skript,"import %s\n",title);
	printf("import %s\n",title);
	PyRun_SimpleString(skript);	
	sprintf(skript,"%s",title);
	newmodule=Py_AddModule(skript);
	if(module==newmodule){
		sprintf(skript,"reload(%s)\n",title);
		PyRun_SimpleString(skript);	
	}
	module=newmodule;
	pnext = get_func(module,"next");
	pdraw = get_func(module,"draw");
	PyErr_Print();
	if(pdraw && pnext){
		printf("Warning: not possible to call python from 2 Threads!!!");
		//pnext=0;
	}
	pinit = get_func(module,"init");
	pinitlegs = get_func(module,"initlegs");
	
	if(pinitlegs ){//&& !_init){
		PyObject*res=call_python2(pinitlegs);
		if(!res){
			printf("PyhthonCall init_legs failed\n");
		}
	}
	if(pinit){
		PyObject*res=call_python2(pinit);
		if(!res){
			printf("PyhthonCall init failed\n");
		}
	}
	//PyEval_ReleaseLock();
	//PyGILState_Release(gstate);

}*/


void pythonnode::import_module(const char *title){
	init_python();
	PyGILState_STATE gstate;
	gstate = PyGILState_Ensure();
	attributes(0);
	modified();
	failed=0;
	PyObject *newmodule=0;
	char skript[255];
	int id=vnodes->id;
	
	sprintf(skript,"import %s",title);
	module=PyImport_ImportModule(title);
	
	/*//imp.load_module('%d',res[0],res[1],res[2])\n
	sprintf(skript,"path,name=import_package('%s')\nimport imp\npath=res=imp.find_module(name,path)\nimp.load_module(res[0][1],res[0],res[1],res[2])\n",title,id);
	//sprintf(skript,"import %s')\nprint(res)\nimp.load_module('%d',res[0],res[1],res[2])\n",title,id);
	printf("import %s\n",title);
	printf("%s",skript);
	PyRun_SimpleString(skript);	
	sprintf(skript,"%d",id);
	module=PyImport_ImportModule(skript);
	*/
	pnext=pdraw=0;
	if(!module){
		PyGILState_Release(gstate);
		return;
	}
	PyImport_ReloadModule(module);
	sprintf(skript,"%s",title);
	
	pinit = get_func(module,"init");
	pinitlegs = get_func(module,"initlegs");
	if(pinitlegs ){//&& !_init){
		PyObject*res=call_python2(pinitlegs);
		if(!res){
			printf("PyhthonCall init_legs failed\n");
		}
	}
	if(pinit){
		PyObject*res=call_python2(pinit);
		if(!res){
			printf("PyhthonCall init failed\n");
		}
	}
	pnext = get_func(module,"next");
	pdraw = get_func(module,"draw");
	PyErr_Print();
	if(pdraw && pnext){
		printf("Warning: not possible to call python from 2 Threads!!!");
		//pnext=0;
	}
	PyGILState_Release(gstate);
}

void pythonnode::pre_process(int time){
	notes.process_midi();
}

pythonnode *actual;

PyThreadState *_save=0;



void pythonnode::panic(){
	//import_module(vnodes->external_name.c_str());
}

void pythonnode::cache_values(int time){
	map<string,Leg *>::iterator it=legs.begin();
	while(it!=legs.end()){
		pair<string,Leg *>p=*it;
		string a=p.first;
		Leg *l=p.second;
		if(a.c_str()[0]=='i'){
			if(a.c_str()[1]=='e'){
				cache[a]=((E_In_Leg *)l)->get_value(time);
			}
			if(a.c_str()[1]=='t'){
				Event *b=((T_In_Leg *)l)->get_event(time);
				if(b){
					cache[a]=1;
				}
			}
		}
		it++;
	}
}

void pythonnode::process(int time){
	if(!normal)return;
	int_process(time);
}

void pythonnode::after_process(int time){
	if(!after)return;
	int_process(time);
}


extern void init_python_for_thread();
extern void pre_python();
extern void after_python();

PyObject *pythonnode::call_python(PyObject *what){
	pre_python();
	PyObject *res=PyObject_CallFunctionObjArgs(what,PyFloat_FromDouble(global_seq->my_time),(PyObject *)this,0);
	if(!res){
		PyErr_Print();		
	}
	after_python();
	return res;
}
PyObject *pythonnode::call_python2(PyObject *what){
	pre_python();
	PyObject *res=PyObject_CallFunctionObjArgs(what,(PyObject *)this,0);	
	if(!res){
		PyErr_Print();		
	}
	after_python();
	return res;
}

void pythonnode::do_non_realtime(){
	if(modified())import_module(vnodes->external_name.c_str());
	if(!non_realtime)return;
	int_process(this->processed_time);
}



void pythonnode::int_process(int time){
	if(failed)return;
	//if(!_save)
//		_save = PyThreadState_New(PyInterpreterState_Head( )) ;
    //PyThreadState* old=PyThreadState_Swap( _save); 
	//PyGILState_STATE gstate=PyGILState_Ensure();
	gtime=time;
	actual=this;
	pre_process(time);
	if(pnext){
		PyObject*res=call_python(pnext);
		//PyObject*res=PyObject_CallFunctionObjArgs(pnext,PyFloat_FromDouble(global_seq->my_time),(PyObject *)this, 0);
		if(!res){
			error_out("PyhthonCall  %s:next failed\n",vnodes->external_name.c_str());
			failed=1;
		}
	}
	if(pdraw){
		cache_values(time);
	}
	//PyGILState_Release(gstate);
	//PyThreadState_Swap( old) ;
}


void pythonnode::gldraw_proceed(const char *key){
	if(legs.find(key)==legs.end())return;
	In_Leg *in=(In_Leg *)legs[key];
	Out_Leg *out=in->out;
	if(!out)return;
	gldrawnode *f=(gldrawnode *)(out->n);
	f->gldraw();

}


void pythonnode::gldraw(){
	if(failed)return;
	if(pdraw){
		PyObject*res=call_python(pdraw);
		if(!res){
			failed=1;
			error_out("%s","PyhthonCall draw failed \n");
		}
	}
	
}


PyObject *pythonnode::py_get_cache(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	float v=n->get_cache(s);
	return PyFloat_FromDouble(v);
};

PyObject *pythonnode::py_get_value(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	float v=n->get_value(s);
	return PyFloat_FromDouble(v);
	};

PyObject *pythonnode::py_gldraw(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	n->gldraw_proceed(s);
	Py_Return;
	};

PyObject *pythonnode::py_set_value(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=actual;//(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	double v=PyFloat_AsDouble(PyTuple_GetItem(args,1));
	n->set_value(s,v);
	Py_Return;
}

PyObject *pythonnode::py_get_event(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	float a=n->get_event(s);
	return PyFloat_FromDouble(a);
	};

PyObject *pythonnode::py_set_event(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	n->set_event(s);
	Py_Return;
	}

PyObject *pythonnode::py_set_signal(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	PyArrayObject *array =  (PyArrayObject *)PyTuple_GetItem(args,1);
	sigt *v=n->get_set_signal(s);
	if(array){
		if(array->nd==1){
			//if(array->dimensions[0]<rate->size)Py_Return;
			for(int j=0;j<array->dimensions[0];j++)
				v[j]=*(double *)(array->data+j*array->strides[0]);
		}
		//Py_XDECREF(array);
	}
	Py_Return;
}

PyObject *pythonnode::py_get_signal(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	int anz;
	sigt *v=n->get_signal(s,anz);
	PyArrayObject *array =  (PyArrayObject *)PyTuple_GetItem(args,1);
	if(array){
		if(array->nd==1){
			//if(array->dimensions[0]<rate->size)Py_Return;
			for(int j=0;j<anz;j++)
				*(double *)(array->data+j*array->strides[0])=v[j];
		}
		//Py_XDECREF(array);
	}
	Py_Return;
}


PyObject *pythonnode::py_set_list(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	PyArrayObject *array =  (PyArrayObject *)PyTuple_GetItem(args,1);
	ev_list *v=n->get_out_list(s);
	if(array){
		if(array->nd==1){
			//if(array->dimensions[0]<rate->size)Py_Return;
			v->change_anz(array->dimensions[0]);
			for(int j=0;j<v->anz;j++){
				v->value[j]=*(double *)(array->data+j*array->strides[0]);
			}
		}
		//Py_XDECREF(array);
	}
	Py_Return;
}

PyObject *pythonnode::py_get_list(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char *s=PyString_AsString(PyTuple_GetItem(args,0));
	PyArrayObject *array =  (PyArrayObject *)PyTuple_GetItem(args,1);
	ev_list *v=n->get_list(s);
	if(!v){
		array->dimensions[0]=v->anz;
		Py_Return;
	}
	if(array->nd==1){
		if(v->anz>0){
			array->dimensions[0]=v->anz;
		}
		for(int j=0;j<v->anz;j++)
			*(double *)(array->data+j*array->strides[0])=v->value[j];
	}
	Py_Return;
}

PyObject *pythonnode::py_get_seq_time(PyObject *self, PyObject *args, PyObject *kwds){
	float a = global_seq->my_time;
	char p=global_seq->playing;
	PyTuple_SetItem(args, 0, PyInt_FromLong(p));
	return PyFloat_FromDouble(a);
}


PyObject *pythonnode::py_note(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	char p=PyInt_AsLong(PyTuple_GetItem(args,0));
	float a=PyFloat_AsDouble(PyTuple_GetItem(args,1));
	char c=PyInt_AsLong(PyTuple_GetItem(args,2));
	float t0=PyFloat_AsDouble(PyTuple_GetItem(args,3));
	n->notes.note_on(p,a,c,my_round(t0*n->rate->kr));
	Py_Return;
}


PyObject *pythonnode::py_dict(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	Py_INCREF(n->dict);

	return n->dict;
}


PyObject *pythonnode::py_get_attr_string(PyObject *self, PyObject *args, PyObject *kwds){
	pythonnode *n=(pythonnode *)self;
	return PyString_FromString(n->a_string.c_str());

	return n->dict;
}


Node *create_pythonnode(){return new pythonnode;}

