
%module sframe

#include <string>
%{
#include "NoteTableItem.h"
#include "VoiceTableItem.h"
#include "Const.h"
#include "Sequencer.h"
#include "Numeric/arrayobject.h"
#include "hash_map.h"
#include "tao.h"
extern void snd_open(const char *name);
extern float *read_file_mono();
extern PyObject *py_mls(int order,int tapset);
extern void fix_tempo(float fre);
extern void send_key(char key);
extern float receive(const char *what);
extern void send(const char *what,float v);
extern TableItem *make_item(int wh,float pos,const char *what);
extern void delete_item(int track,TableItem *);
extern void set_item(int wh,float pos,const char *what);
extern const char *get_item_text(int wh,float pos);
extern float seq_time();
extern void delete_items(int wh,float t0,float t1);
extern void set_loop(float t0,float t1);
extern void set_seq_inc(float inc);
extern const char *get_type(int wh);

extern NoteTableItem *get_note_item(int wh,float pos);
extern VoiceTableItem *get_voice_item(int wh,float pos);
extern Const *get_const(int track,const char *name);

extern void menu_command(const char *what);


extern PyObject *get_list(Node *n);
extern Node *get_node(const char *name);
extern void stop_audio();
extern void start_audio();
extern void process();
extern void start_recording();
extern void stop_recording(bool showing);
extern void create_glext(PyObject *n,int x,int y,int w,int h,const char *l);

extern void IntNoteOn(char which,char amp,char channel);
extern void IntNoteOff(char which,char channel);
extern void change_rate(float sr,int size);
extern void dump();
extern void setConsts(PyObject *values);
%}

//#include "swig_helpers.h"
//%include "tao.i"

%include "carrays.i"
%array_class(float,floatArray);
%include "/../includes/tao.h"

using namespace std;

PyObject* pystring(string& s);
string cstring(PyObject* o);

class TableItem{
public:
};

extern PyObject *py_mls(int order,int tapset);
extern void fix_tempo(float fre);
extern void send_key(char key);
extern float receive(const char *what);
extern void send(const char *what,float v);
extern TableItem *make_item(int wh,float pos,const char *what);
extern void delete_item(int track,TableItem *);
extern void set_item(int wh,float pos,const char *what);
extern const char *get_item_text(int wh,float pos);
extern float seq_time();
extern void delete_items(int wh,float t0,float t1);
extern void set_loop(float t0,float t1);
extern void set_seq_inc(float inc);
extern const char *get_type(int wh);

class NoteTableItem{
public:
void create_note_old(int snap,int stime,int wh,float a,float slen,int family);
int  edit_special();
void make_item(float t,int wh,float a,float d);
void clear();
};


class VoiceTableItem{
public:
void set_items(const char *what);
void clear();
};


class Const{
public:
 void set_to(float x);
 void set_from_value(float x);
 float min,max,step,value;
};



class Node{
public:
void double_click();   
void set_input_signal(PyObject *array);
void clear_input_signal();
};



extern NoteTableItem *get_note_item(int wh,float pos);
extern VoiceTableItem *get_voice_item(int wh,float pos);
extern Const *get_const(int track,const char *name);

void menu_command(const char *what);


extern PyObject *get_list(Node *n);
extern Node *get_node(const char *name);
extern void stop_audio();
extern void start_audio();
extern void process();
extern void start_recording();
extern void stop_recording(bool showing);
extern void create_glext(PyObject *n,int x,int y,int w,int h,const char *l);

extern void IntNoteOn(char which,char amp,char channel);
extern void IntNoteOff(char which,char channel);
extern void change_rate(float sr,int size);
extern void dump();
extern void setConsts(PyObject *values);

class hash_map:public Node{
public:
  void load();
  bool active;
};

