#include "sndfile.h"


float *read_file_mono(const char *name){
	SF_INFO ginfo;
	SNDFILE *gfile=sf_open(name,SFM_READ,&ginfo);
	long size=ginfo.frames;
	float *fsamps;
	if(size > 1000000){
		printf("sample too large to be read in memory\n");
		size=1000000;
	}
	fsamps=new float[2*(256+size)];
	int l=sf_readf_float(gfile,fsamps,size);
	if(ginfo.channels>1){
		float *temp=new float[size>>1];
		int ind=0;
		for(int j=0;j<size;j+=2){
			temp[ind++]=fsamps[j];
		}
		delete [] fsamps;
		fsamps=temp;
	}
	return fsamps;
}

void write_file_mono(const char *name,float *samps,int n){
	SF_INFO ginfo;
	ginfo.channels=1;
	ginfo.frames=n;
	ginfo.samplerate=44100;
	ginfo.format= SF_FORMAT_WAV | SF_FORMAT_PCM_16;
	SNDFILE *gfile=sf_open(name,SFM_WRITE,&ginfo);
	int l=sf_writef_float(gfile,samps,n);
}
